```mermaid
graph LR
    RIronIngot((IronIngot))
    RIronIngotLava((IronIngotLava))
    RSilverIngot((SilverIngot))
    RSilverIngotLava((SilverIngotLava))
    RAdamantiteIngot((AdamantiteIngot))
    RPlank((Plank))
    RIronGear((IronGear))
    RCrank((Crank))
    RMetalPlating((MetalPlating))
    RGadget((Gadget))
    RGlass((Glass))
    RGlassLava((GlassLava))
    RFiberglass((Fiberglass))
    RQuartz((Quartz))
    RRubber((Rubber))
    RConcrete((Concrete))
    RCeramic((Ceramic))
    RCermet((Cermet))
    RCermetLava((CermetLava))
    RReinforcedPlating((ReinforcedPlating))
    RTemperedGlass((TemperedGlass))
    RLens((Lens))
    RHyperLens((HyperLens))
    RManaFiber((ManaFiber))
    RMagicite((Magicite))
    RManaCore((ManaCore))
    RBoundComposite((BoundComposite))
    RManaSubstance((ManaSubstance))
    RHyperCatalyst((HyperCatalyst))
    RObsidian((Obsidian))
    RAether((Aether))
    RSolidifiedAether((SolidifiedAether))
    RSynthEgg((SynthEgg))
    RRepairTools((RepairTools))
    RFertilizer((Fertilizer))
    RFireOrb((FireOrb))
    RWaterOrb((WaterOrb))
    RWindOrb((WindOrb))
    REarthOrb((EarthOrb))
    RSawblade((Sawblade))
    RTapper((Tapper))
    RShears((Shears))
    RTrowel((Trowel))
    RManaBullet((ManaBullet))
    RManaBulletII((ManaBulletII))
    RHyperBullet((HyperBullet))
    RMetal((Metal))
    RMineral((Mineral))
    RMana((Mana))
    RBiomass((Biomass))
    RMetalII((MetalII))
    RMineralII((MineralII))
    RManaII((ManaII))
    RBiomassII((BiomassII))
    RMechanicalEssence((MechanicalEssence))
    RMagicalEssence((MagicalEssence))
    RMartialEssence((MartialEssence))
    RStructuralEssence((StructuralEssence))
    RTechnologicalEssence((TechnologicalEssence))
    RHyperEssence((HyperEssence))
    RRapidBonder((RapidBonder))
    RHeavyBonder((HeavyBonder))
    RConductiveBonder((ConductiveBonder))
    RScaffolding((Scaffolding))
    RLadder((Ladder))
    RBrick((Brick))
    RStructuralFraming((StructuralFraming))
    RTorch((Torch))
    RTransportTube((TransportTube))
    RTransportTubeII((TransportTubeII))
    RTransportTubeIII((TransportTubeIII))
    RSplitter((Splitter))
    RSplitterII((SplitterII))
    RSplitterIII((SplitterIII))
    RBypass((Bypass))
    RBypassII((BypassII))
    RBypassIII((BypassIII))
    RPorter((Porter))
    RPorterII((PorterII))
    RBeamDock((BeamDock))
    RBeamBoost((BeamBoost))
    RBeamBoostII((BeamBoostII))
    RPipe((Pipe))
    RLargePipe((LargePipe))
    RPump((Pump))
    RStorageTank((StorageTank))
    RCrankDrill((CrankDrill))
    RCombustionDrill((CombustionDrill))
    REnergyDrill((EnergyDrill))
    RForge((Forge))
    RLavaForge((LavaForge))
    RAssembler((Assembler))
    RAssemblerII((AssemblerII))
    RAssemblerIII((AssemblerIII))
    RMatterRefiner((MatterRefiner))
    RMatterCompressor((MatterCompressor))
    RDistiller((Distiller))
    RFoldery((Foldery))
    RInfuser((Infuser))
    RElementalizer((Elementalizer))
    RMonsterStable((MonsterStable))
    RPlantSupport((PlantSupport))
    RIrrigatedPlantSupport((IrrigatedPlantSupport))
    RWoodChest((WoodChest))
    RSturdyChest((SturdyChest))
    RCrankGenerator((CrankGenerator))
    RPowerChamber((PowerChamber))
    RReactor((Reactor))
    RPowerRelay((PowerRelay))
    RPowerRelayII((PowerRelayII))
    RPowerRelayIII((PowerRelayIII))
    RPowerTransmitter((PowerTransmitter))
    RElementalConverter((ElementalConverter))
    RElementalRelay((ElementalRelay))
    RElementalRelayII((ElementalRelayII))
    RBattery((Battery))
    RCollector((Collector))
    RManaTurret((ManaTurret))
    RFireTurret((FireTurret))
    RWaterTurret((WaterTurret))
    RWindTurret((WindTurret))
    REarthTurret((EarthTurret))
    T1{{BasicExtraction Tech}}
    T2{{Foundations Tech}}
    T3{{PowerProduction Tech}}
    T4{{BasicTransportation Tech}}
    T5{{Automation Tech}}
    T6{{EssenceFolding Tech}}
    T7{{RefinementProcess Tech}}
    T8{{ConduitTapping Tech}}
    T9{{MetalPlating Tech}}
    T10{{Quartz Tech}}
    T11{{Porter Tech}}
    T12{{MagicDistillation Tech}}
    T13{{Fortification Tech}}
    T14{{StructuralRestoration Tech}}
    T15{{Gadget Tech}}
    T16{{Magicite Tech}}
    T17{{IntermediatePowerProduction Tech}}
    T18{{PoweredExtraction Tech}}
    T19{{Battery Tech}}
    T20{{Farming Tech}}
    T21{{Tapper Tech}}
    T22{{Trowel Tech}}
    T23{{Fiberglass Tech}}
    T24{{ManaCore Tech}}
    T25{{PowerTransmission Tech}}
    T26{{IntermediateConduitTapping Tech}}
    TStarting{{Starting}}
    T1 --> RCombustionDrill
    T1 --> RIronGear
    T2 --> RScaffolding
    T2 --> RLadder
    T2 --> RBrick
    T3 --> RCrankGenerator
    T3 --> RPowerRelay
    T4 --> RTransportTube
    T4 --> RSplitter
    T4 --> RBypass
    T3 ==> T5
    T5 --> RAssembler
    T5 ==> T6
    T6 --> RMechanicalEssence
    T6 --> RDistiller
    T6 --> RFoldery
    T6 ==> T7
    T7 --> RMatterRefiner
    T7 --> RMetal
    T7 --> RMineral
    T7 --> RMana
    T7 --> RBiomass
    T7 ==> T8
    T8 --> RConduitTapping
    T7 ==> T9
    T9 --> RMetalPlating
    T6 ==> T10
    T10 --> RQuartz
    T4 ==> T11
    T10 ==> T11
    T11 --> RPorter
    T6 ==> T12
    T12 --> RManaFiber
    T12 --> RMagicalEssence
    T6 ==> T13
    T13 --> RManaBullet
    T13 --> RManaTurret
    T6 ==> T14
    T14 --> RRepairTools
    T12 ==> T15
    T15 --> RGadget
    T12 ==> T16
    T16 --> RMagicite
    T16 ==> T17
    T17 --> RPowerChamber
    T16 ==> T18
    T18 --> REnergyDrill
    T16 ==> T19
    T19 --> RBattery
    T16 ==> T20
    T20 --> RFertilizer
    T20 --> RSawblade
    T20 --> RPlantSupport
    T15 ==> T21
    T20 ==> T21
    T21 --> RTapper
    T20 ==> T22
    T22 --> RTrowel
    T12 ==> T23
    T23 --> RFiberglass
    T16 ==> T24
    T23 ==> T24
    T24 --> RManaCore
    T9 ==> T25
    T15 ==> T25
    T25 --> RPowerRelayII
    T25 --> RPowerTransmitter
    T8 ==> T26
    T25 ==> T26
    T26 --> RConduitTapping2
    TStarting --> RIronIngot
    TStarting --> RSilverIngot
    TStarting --> RPlank
    TStarting --> RCrank
    TStarting --> RGlass
    TStarting --> RTorch
    TStarting --> RCrankDrill
    TStarting --> RForge
    TStarting --> RWoodChest
```