local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 3,["9"] = 3,["11"] = 4,["12"] = 5,["13"] = 6,["14"] = 7,["15"] = 8,["16"] = 9,["17"] = 10,["18"] = 12,["19"] = 13,["20"] = 14,["21"] = 3,["27"] = 17,["29"] = 19,["30"] = 20,["31"] = 21,["40"] = 25,["44"] = 28,["45"] = 29,["46"] = 28,["47"] = 32,["48"] = 33,["49"] = 32,["50"] = 36,["51"] = 37,["52"] = 38,["53"] = 39,["54"] = 39,["55"] = 39,["56"] = 39,["57"] = 39,["58"] = 39,["59"] = 39,["60"] = 40,["61"] = 36,["62"] = 43,["63"] = 44,["64"] = 45,["65"] = 46,["66"] = 43,["67"] = 49,["68"] = 50,["69"] = 51,["70"] = 52,["73"] = 56,["74"] = 57,["75"] = 58,["76"] = 59,["78"] = 62,["79"] = 63,["80"] = 64,["81"] = 65,["82"] = 66,["83"] = 67,["84"] = 68,["85"] = 69,["87"] = 49,["88"] = 73,["89"] = 74,["90"] = 75,["92"] = 77,["93"] = 78,["94"] = 79,["95"] = 79,["96"] = 79,["97"] = 79,["98"] = 79,["99"] = 80,["100"] = 80,["101"] = 80,["102"] = 80,["103"] = 80,["104"] = 81,["105"] = 82,["106"] = 73,["107"] = 85,["108"] = 86,["109"] = 87,["110"] = 88,["111"] = 89,["113"] = 85,["114"] = 94,["115"] = 95,["116"] = 96,["118"] = 99,["119"] = 100,["120"] = 94,["121"] = 104});
local ____exports = {}
local ACCESSIBILITY_SCREENSHAKE = HashString("Screenshake")
local Camera = __TS__Class()
Camera.name = "Camera"
function Camera.prototype.____constructor(self)
    self.entityID = INVALID_ENTITYID
    self.position = Vector.new()
    self.viewport = Rect.new()
    self._zoom = 1
    self.mousePosition = Vector.new()
    self.offset = Vector.new()
    self.bounds = Rect.new()
    self.shakeTimer = GameTimer.new()
    self.shakeAmount = 0
    self.shakeSfx = audio.play("event:/GENERAL/SCREENSHAKE_LOOP")
end
__TS__SetDescriptor(
    Camera.prototype,
    "zoom",
    {
        get = function(self)
            return self._zoom
        end,
        set = function(self, value)
            self._zoom = value
            Renderer.setCamera(self.viewport, self._zoom, self.bounds)
        end
    },
    true
)
__TS__SetDescriptor(
    Camera.prototype,
    "isAttached",
    {get = function(self)
        return self.entityID ~= INVALID_ENTITYID
    end},
    true
)
function Camera.prototype.attach(self, entityID)
    self.entityID = entityID
end
function Camera.prototype.detach(self)
    self.entityID = INVALID_ENTITYID
end
function Camera.prototype.set(self, position)
    self.position = position
    local size = Renderer.getSize():asVector()
    self.viewport = Rect.fromCenter(
        Vector.new(
            math.floor(position.x),
            math.floor(position.y)
        ),
        size
    )
    Renderer.setCamera(self.viewport, self._zoom, self.bounds)
end
function Camera.prototype.moveBy(self, delta)
    local center = self.viewport:center()
    center:move(-delta.x / self._zoom, -delta.y / self._zoom)
    self:set(center)
end
function Camera.prototype.update(self, frameTime)
    if self.entityID ~= INVALID_ENTITYID then
        if not EntityManager.has(self.entityID) then
            self:detach()
            return
        end
        local entity = EntityManager.get(self.entityID)
        local position = entity.transform.position:copy()
        position = position + self.offset
        self:set(position)
    end
    if not self.shakeTimer:expired() then
        local percentage = 1 - self.shakeTimer:percentage()
        local x = Random.get(-self.shakeAmount, self.shakeAmount) * percentage
        local y = Random.get(-self.shakeAmount, self.shakeAmount) * percentage
        self:moveBy(Vector.new(x, y))
    elseif self.shakeAmount ~= 0 then
        self.shakeSfx:stop(FMODStopMode.FMOD_STUDIO_STOP_ALLOWFADEOUT)
        self.shakeAmount = 0
    end
end
function Camera.prototype.screenToWorld(self, position, zoom)
    if zoom == nil then
        zoom = self._zoom
    end
    local result = self.viewport:center()
    result:move(-self.viewport.width / (zoom * 2), -self.viewport.height / (zoom * 2))
    result.x = clamp(
        result.x,
        self.bounds.x,
        self.bounds:right() - self.viewport.width / zoom
    )
    result.y = clamp(
        result.y,
        self.bounds.y,
        self.bounds:bottom() - self.viewport.height / zoom
    )
    result:move(position.x / zoom, position.y / zoom)
    return result
end
function Camera.prototype.shake(self, duration, amount)
    self.shakeTimer:reset(duration)
    self.shakeAmount = amount * (settings.getInt(ACCESSIBILITY_SCREENSHAKE) / 100)
    if self.shakeAmount > 0 then
        self.shakeSfx:start()
    end
end
function Camera.prototype.getPosition(self)
    if not self.isAttached or not EntityManager.has(self.entityID) then
        return self.position
    end
    local entity = EntityManager.get(self.entityID)
    return entity.transform.position
end
____exports.Camera = Camera
return ____exports
