local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__New = ____lualib.__TS__New
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 21,["11"] = 21,["12"] = 62,["13"] = 51,["14"] = 55,["15"] = 58,["16"] = 60,["17"] = 63,["18"] = 64,["19"] = 65,["20"] = 66,["21"] = 67,["22"] = 68,["24"] = 70,["26"] = 62,["32"] = 28,["34"] = 31,["35"] = 32,["45"] = 36,["47"] = 39,["48"] = 40,["58"] = 44,["60"] = 47,["61"] = 48,["66"] = 74,["67"] = 75,["68"] = 74,["69"] = 78,["70"] = 79,["71"] = 80,["73"] = 83,["74"] = 84,["75"] = 84,["76"] = 84,["77"] = 84,["78"] = 85,["79"] = 86,["80"] = 87,["82"] = 89,["83"] = 90,["85"] = 92,["86"] = 78,["87"] = 95,["88"] = 96,["89"] = 95,["90"] = 22,["91"] = 23,["92"] = 24,["93"] = 100,["94"] = 100});
local ____exports = {}
local ____event = require("event")
local Event = ____event.Event
local ProducerComponent = __TS__Class()
ProducerComponent.name = "ProducerComponent"
function ProducerComponent.prototype.____constructor(self, producer)
    self.entityID = INVALID_ENTITYID
    self.onEmpty = __TS__New(Event)
    self.updateStore = 0
    self.updateDraw = 0
    self.stored = producer.stored or producer.capacity
    self.generate = producer.generate
    self.throughput = producer.throughput
    self.capacity = producer.capacity
    if producer.onStorageChange then
        self.onStorageChange = producer.onStorageChange:copy()
    else
        self.onStorageChange = __TS__New(Event)
    end
end
__TS__SetDescriptor(
    ProducerComponent.prototype,
    "stored",
    {
        get = function(self)
            return self.data:getUint32(0)
        end,
        set = function(self, value)
            self.data:setUint32(0, value)
        end
    },
    true
)
__TS__SetDescriptor(
    ProducerComponent.prototype,
    "generate",
    {
        get = function(self)
            return self.data:getUint32(1)
        end,
        set = function(self, value)
            self.data:setUint32(1, value)
        end
    },
    true
)
__TS__SetDescriptor(
    ProducerComponent.prototype,
    "throughput",
    {
        get = function(self)
            return self.data:getUint32(2)
        end,
        set = function(self, value)
            self.data:setUint32(2, value)
        end
    },
    true
)
function ProducerComponent.prototype.create(self, entity)
    self.entityID = entity.id
end
function ProducerComponent.prototype.setStored(self, value)
    if self.stored == value then
        return 0
    end
    local previous = self.stored
    self.stored = math.max(
        0,
        math.min(value, self.capacity)
    )
    log.info("Power change to " .. tostring(self.stored))
    if self.stored == 0 then
        self.onEmpty:invoke()
    end
    if self.onStorageChange ~= nil then
        self.onStorageChange:invoke(self.entityID, previous, self.stored, self.capacity)
    end
    return self.stored - previous
end
function ProducerComponent.prototype.adjustStored(self, value)
    return self:setStored(self.stored + value)
end
ProducerComponent.type = "producer"
ProducerComponent.cid = hash.hash_str32(ProducerComponent.type)
ProducerComponent.serialization = 3
____exports.ProducerComponent = ProducerComponent
____exports.component = ProducerComponent
return ____exports
