local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["9"] = 2,["10"] = 2,["11"] = 7,["12"] = 3,["13"] = 4,["14"] = 5,["15"] = 8,["16"] = 9,["18"] = 7,["19"] = 13,["20"] = 14,["21"] = 15,["22"] = 16,["23"] = 17,["24"] = 13,["25"] = 20,["26"] = 21,["27"] = 22,["28"] = 23,["29"] = 24,["30"] = 20,["31"] = 27,["32"] = 28,["33"] = 27,["34"] = 31,["35"] = 33,["36"] = 31,["37"] = 36,["38"] = 37,["39"] = 38,["40"] = 36,["41"] = 41,["42"] = 42,["43"] = 41,["44"] = 45,["45"] = 47,["46"] = 48,["47"] = 49,["48"] = 51,["49"] = 52,["50"] = 53,["53"] = 56,["54"] = 57,["55"] = 58,["58"] = 61,["59"] = 45,["60"] = 67,["61"] = 68,["63"] = 71,["64"] = 73,["65"] = 74,["66"] = 75,["67"] = 76,["68"] = 77,["69"] = 79,["70"] = 79});
local ____exports = {}
local Event = __TS__Class()
Event.name = "Event"
function Event.prototype.____constructor(self, listener)
    self.listeners = __TS__New(Map)
    self.invoking = false
    self.ids = 1
    if listener then
        self:listen(listener)
    end
end
function Event.prototype.copy(self)
    local event = __TS__New(Event)
    event.listeners = __TS__New(Map, self.listeners)
    event.ids = self.ids
    return event
end
function Event.prototype.listen(self, listener)
    local id = self.ids
    self.ids = self.ids + 1
    self.listeners:set(id, listener)
    return id
end
function Event.prototype.has(self, id)
    return self.listeners:has(id)
end
function Event.prototype.remove(self, id)
    return self.listeners:delete(id)
end
function Event.prototype.clear(self)
    self.listeners:clear()
    self.ids = 1
end
function Event.prototype.empty(self)
    return self.listeners.size == 0
end
function Event.prototype.invoke(self, ...)
    self.invoking = true
    local destroyed = {}
    for ____, id in __TS__Iterator(self.listeners:keys()) do
        local listener = self.listeners:get(id)
        if listener(...) == false then
            destroyed[#destroyed + 1] = id
        end
    end
    if #destroyed > 0 then
        for ____, id in ipairs(destroyed) do
            self.listeners:delete(id)
        end
    end
    self.invoking = false
end
if _G.GameEvents == nil then
    _G.GameEvents = {}
end
local GameEvents = _G.GameEvents
_G.GameEvents.updateStart = __TS__New(Event)
_G.GameEvents.update = __TS__New(Event)
_G.GameEvents.updateFixed = __TS__New(Event)
_G.GameEvents.resolutionResize = __TS__New(Event)
_G.GameEvents.plantHarvested = __TS__New(Event)
____exports.GameEvents = GameEvents
____exports.Event = Event
return ____exports
