local ____lualib = require("lualib_bundle")
local __TS__StringEndsWith = ____lualib.__TS__StringEndsWith
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 5,["15"] = 5,["16"] = 6,["17"] = 6,["18"] = 9,["19"] = 11,["20"] = 13,["21"] = 17,["22"] = 19,["23"] = 21,["24"] = 26,["25"] = 31,["26"] = 31,["27"] = 33,["28"] = 34,["29"] = 34,["30"] = 34,["31"] = 34,["32"] = 34,["33"] = 34,["34"] = 31,["35"] = 31,["36"] = 38,["37"] = 39,["38"] = 39,["39"] = 39,["40"] = 40,["41"] = 41,["42"] = 42,["45"] = 46,["46"] = 46,["47"] = 46,["48"] = 46,["49"] = 47,["50"] = 48,["51"] = 49,["52"] = 49,["53"] = 49,["54"] = 50,["55"] = 49,["56"] = 49,["57"] = 52,["58"] = 52,["59"] = 52,["60"] = 53,["61"] = 52,["62"] = 52,["63"] = 55,["64"] = 56,["66"] = 58,["69"] = 62,["70"] = 63,["71"] = 64,["72"] = 66,["73"] = 67,["74"] = 67,["75"] = 67,["76"] = 68,["77"] = 67,["78"] = 67,["79"] = 70,["80"] = 66,["81"] = 39,["82"] = 38,["83"] = 73,["84"] = 73,["85"] = 73,["86"] = 74,["87"] = 75,["88"] = 76,["89"] = 73,["90"] = 38,["91"] = 38,["92"] = 80,["93"] = 82,["94"] = 83,["95"] = 83,["96"] = 84,["97"] = 84,["98"] = 84,["99"] = 83,["100"] = 85,["101"] = 85,["102"] = 85,["103"] = 83,["104"] = 83,["105"] = 82,["106"] = 89,["107"] = 95,["108"] = 95,["109"] = 95,["110"] = 95});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local ____base = require("ui.base")
local showDialog = ____base.showDialog
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("apotheos")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/APOTHEOS/APO_AMBIENCE", autostart = true})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(7, 13),
            "apotheos-1"
        )}
    )}
})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            local dialog = UIManager.get("Apotheos")
            if dialog.view:isVisible() then
                dialog:hide()
                return
            end
            if __TS__StringEndsWith(
                entity.animation:current().name:str(),
                "off"
            ) then
                audio.start("event:/APOTHEOS/APO_WAKEUP", entity.transform.position)
                SceneManager.get().camera:shake(300, 4)
                scheduler:add(
                    seconds(1),
                    function()
                        SceneManager.get().camera:shake(300, 4)
                    end
                )
                scheduler:add(
                    seconds(1.6),
                    function()
                        SceneManager.get().camera:shake(2000, 10)
                    end
                )
                animator.play(entity, "activate")
                animator.queue(entity, "idle", true)
                return
            elseif animator.isCurrentlyPlaying(entity, "activate") then
                return
            end
            audio.start("event:/APOTHEOS/APO_HOLOGRAM_OPEN", entity.transform.position)
            animator.play(entity, "interact_activate")
            animator.queue(entity, "interact_idle", true)
            entity.animation.onFinished:listen(function(____, name)
                scheduler:add(
                    100,
                    function()
                        showDialog(nil, "Apotheos", entity)
                    end
                )
                return false
            end)
        end
    ),
    withdraw = __TS__New(
        Event,
        function(player, entity)
            audio.start("event:/APOTHEOS/APO_HOLOGRAM_CLOSE", entity.transform.position)
            animator.play(entity, "interact_deactivate")
            animator.queue(entity, "idle", true)
        end
    )
})
prefab:addApotheos({})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(9999, 9999, 9999)
        },
        {
            "DEF",
            Stat.new(99, 99, 99)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.None, isInvincible = true})
prefab:addLight({
    intensity = 160,
    color = Color.new(158, 228, 255)
})
return ____exports
