local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 8,["18"] = 10,["19"] = 12,["20"] = 16,["21"] = 20,["22"] = 24,["23"] = 25,["24"] = 25,["25"] = 26,["26"] = 25,["27"] = 24,["28"] = 30,["29"] = 32,["30"] = 34,["31"] = 36,["32"] = 36,["33"] = 36,["34"] = 36,["35"] = 41,["36"] = 46,["37"] = 46,["38"] = 48,["39"] = 49,["40"] = 49,["41"] = 49,["42"] = 49,["43"] = 49,["44"] = 49,["45"] = 46,["46"] = 46,["47"] = 53,["48"] = 57,["49"] = 62,["50"] = 68,["51"] = 69,["52"] = 69,["53"] = 70,["54"] = 70,["55"] = 70,["56"] = 69,["57"] = 71,["58"] = 71,["59"] = 71,["60"] = 69,["61"] = 69,["62"] = 68,["63"] = 75,["64"] = 79,["65"] = 79,["66"] = 79,["67"] = 79,["68"] = 83,["69"] = 84,["70"] = 85,["71"] = 86,["72"] = 86,["73"] = 86,["74"] = 86,["75"] = 79,["76"] = 88,["77"] = 89,["78"] = 90,["79"] = 91,["80"] = 92,["81"] = 93,["83"] = 95,["84"] = 96,["85"] = 97,["86"] = 98,["87"] = 98,["88"] = 98,["89"] = 98,["90"] = 79,["91"] = 100,["92"] = 101,["93"] = 102,["94"] = 103,["95"] = 104,["96"] = 105,["97"] = 106,["98"] = 107,["99"] = 108,["100"] = 109,["101"] = 110,["103"] = 112,["105"] = 79,["106"] = 79,["107"] = 117});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____conduit = require("systems.conduit")
local CONDUIT_TIERS = ____conduit.CONDUIT_TIERS
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_power_relay_iii"})
prefab:addInventory({inventories = {{size = 1, features = InventoryFeatures.None, filterPrefabs = {INVALID_ENTITYID}}}})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "ManaConduit", entity)
    end
)})
prefab:addRender("mana_conduit-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "0", loop = true})
prefab:addLight({
    intensity = 230,
    color = Color.new(100, 220, 255)
})
prefab:addAmbience({sfx = "event:/FABRICATORS/MANA_CONDUIT_LOOP", autostart = true})
prefab:addPlacement({
    features = bit.bor(PlacementFeatures.Targetable, PlacementFeatures.Indestructible),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 4),
            "0"
        )}
    )}
})
prefab:addCollector({reach = 1})
prefab:addDistributor({area = 0, range = 0})
prefab:addProducer({generate = 250, throughput = 250, capacity = 0})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        }
    }
)})
prefab:addBehavior({tree = BehaviorTree.new("mana_conduit"):root(ReactiveSelectorNode.new("root"))})
prefab:addCombat({
    team = CombatTeam.Structure,
    isInvincible = true,
    destroyOnDeath = false,
    initialize = function(entity)
        local data = entity.behavior.data
        data:setBool("regenerating", false)
        data:setTimer(
            "attackTimer",
            GameTimer.new()
        )
    end,
    onDeath = function(____, entity)
        entity.producer.generate = 0
        local conduit = entity.conduit
        entity.inventory:get().features = InventoryFeatures.None
        if conduit.partition > 0 then
            conduit.partition = conduit.partition - 1
        end
        animator.play(entity, CONDUIT_TIERS[conduit.tier + 1].disabled)
        local data = entity.behavior.data
        data:setBool("regenerating", true)
        local timer = data:setTimer(
            "attackTimer",
            GameTimer.new(minutes(2))
        )
    end,
    onUpdate = function(____, frameTime, entity, combat)
        local data = entity.behavior.data
        if data:getBool("regenerating") and data:getTimer("attackTimer"):expired() then
            local hp = entity.stats:get("HP")
            hp:setCurrent(hp:get())
            local conduit = entity.conduit
            animator.play(entity, CONDUIT_TIERS[conduit.tier + 1].animation, true)
            local producer = entity.producer
            producer.generate = producer.throughput
            if not conduit:requiresUnlock() then
                entity.inventory:get().features = InventoryFeatures.Collect
            end
            data:setBool("regenerating", false)
        end
    end
})
prefab:addConduit()
return ____exports
