local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 6,["16"] = 6,["17"] = 7,["18"] = 7,["19"] = 10,["20"] = 12,["21"] = 16,["22"] = 20,["23"] = 25,["24"] = 27,["25"] = 29,["26"] = 34,["27"] = 38,["28"] = 40,["29"] = 40,["30"] = 40,["31"] = 40,["32"] = 38,["33"] = 44,["34"] = 44,["35"] = 44,["36"] = 47,["37"] = 48,["38"] = 48,["39"] = 49,["40"] = 49,["41"] = 49,["42"] = 48,["43"] = 44,["44"] = 44,["45"] = 54,["46"] = 54,["47"] = 54,["48"] = 54,["49"] = 59,["50"] = 64,["51"] = 65,["52"] = 65,["53"] = 65,["54"] = 66,["55"] = 65,["56"] = 64,["57"] = 68,["58"] = 68,["59"] = 68,["60"] = 69,["61"] = 70,["62"] = 71,["63"] = 72,["64"] = 73,["66"] = 68,["67"] = 64,["68"] = 64,["69"] = 78,["70"] = 84,["71"] = 85,["72"] = 85,["73"] = 86,["74"] = 86,["75"] = 86,["76"] = 85,["77"] = 87,["78"] = 87,["79"] = 87,["80"] = 85,["81"] = 88,["82"] = 88,["83"] = 88,["84"] = 85,["85"] = 89,["86"] = 89,["87"] = 89,["88"] = 85,["89"] = 85,["90"] = 84,["91"] = 93,["92"] = 100,["93"] = 104,["94"] = 104,["95"] = 106,["96"] = 107,["97"] = 108,["99"] = 110,["101"] = 104,["102"] = 104});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____mechanical = require("components.mechanical")
local MechanicalNodeType = ____mechanical.MechanicalNodeType
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform({origin = Vector.new(16, 16)})
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_crank_drill", stack = 20})
prefab:addRender("crank_drill-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/DRILL_LOOP"})
prefab:addInventory({inventories = {{
    name = "output",
    size = 1,
    filterPrefabs = {INVALID_ENTITYID},
    features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
}}})
prefab:addPlacement({
    drop = Prefab.getID("structure.crank_drill"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Backwall,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 2),
            "crank_drill-1"
        )}
    )}
})
prefab:addDrill({
    speed = seconds(9),
    range = 0
})
prefab:addDispenser({frequency = 500, isEnabled = true})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "CrankDrill", entity)
        end
    ),
    cranked = __TS__New(
        Event,
        function(player, entity)
            local nrg = entity.stats:get("NRG")
            local wasEmpty = nrg:getCurrent() == 0
            nrg:adjustCurrent(7)
            if wasEmpty then
                entity.consumer:addState(ConsumerState.Powered)
            end
        end
    )
})
prefab:addConsumer({isAutonomous = true, idlePower = 0, activePower = 3})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(600, 600, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay({noPowerIndicator = atlases.get("autoforge_window_no_crank")})
prefab:addMechanical({
    inputs = {MechanicalNodeType.Basic},
    onReceive = function(____, mechanical, output, input, connection)
        if connection.signal.strength == 1 then
            input.consumer:addState(ConsumerState.On)
        else
            input.consumer:removeState(ConsumerState.On)
        end
    end
})
return ____exports
