local ____lualib = require("lualib_bundle")
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 7,["20"] = 7,["21"] = 8,["22"] = 8,["23"] = 11,["24"] = 13,["25"] = 15,["26"] = 19,["27"] = 24,["28"] = 26,["29"] = 32,["30"] = 34,["31"] = 34,["32"] = 34,["33"] = 34,["34"] = 34,["35"] = 34,["36"] = 33,["37"] = 35,["38"] = 35,["39"] = 35,["40"] = 35,["41"] = 35,["42"] = 33,["43"] = 32,["44"] = 39,["45"] = 43,["46"] = 43,["47"] = 45,["48"] = 45,["49"] = 45,["50"] = 43,["51"] = 46,["52"] = 47,["53"] = 47,["54"] = 48,["55"] = 48,["56"] = 48,["57"] = 47,["58"] = 43,["59"] = 43,["60"] = 53,["61"] = 60,["62"] = 67,["63"] = 68,["64"] = 68,["65"] = 68,["66"] = 69,["67"] = 68,["68"] = 67,["69"] = 71,["70"] = 71,["71"] = 71,["72"] = 72,["73"] = 72,["74"] = 72,["75"] = 73,["76"] = 74,["77"] = 75,["78"] = 76,["79"] = 76,["80"] = 76,["81"] = 76,["82"] = 77,["83"] = 78,["84"] = 79,["87"] = 72,["88"] = 72,["89"] = 71,["90"] = 67,["91"] = 67,["92"] = 86,["93"] = 92,["94"] = 96,["95"] = 101,["96"] = 102,["97"] = 102,["98"] = 103,["99"] = 103,["100"] = 103,["101"] = 102,["102"] = 104,["103"] = 104,["104"] = 104,["105"] = 102,["106"] = 105,["107"] = 105,["108"] = 105,["109"] = 102,["110"] = 102,["111"] = 101,["112"] = 109,["113"] = 115});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____world = require("world")
local World = ____world.World
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_elementalizer", stack = 20})
prefab:addRender("elementalizer_empty-1")
prefab:addAnimation({association = "elementalizer_empty", start = "idle", loop = true})
prefab:addInventory({inventories = {
    {
        name = "input-0",
        size = 1,
        collectStack = 10,
        stackOverride = 50,
        filterPrefabs = {Prefab.getID("material.mana")}
    },
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw)
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.elementalizer"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "elementalizer_empty-1"
        )}
    )}
})
local BIOME_ELEMENTS = __TS__New(Map, {{BiomeType.Fire, "fire"}, {BiomeType.Earth, "earth"}, {BiomeType.Water, "water"}, {BiomeType.Wind, "wind"}})
local BIOME_RECIPES = __TS__New(Map, {{BiomeType.Fire, "FireOrb"}, {BiomeType.Earth, "EarthOrb"}, {BiomeType.Water, "WaterOrb"}, {BiomeType.Wind, "WindOrb"}})
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "Elementalizer", entity)
        end
    ),
    placed = __TS__New(
        Event,
        function(entity)
            scheduler:add(
                1,
                function()
                    local realm = World:get(entity.location.realm)
                    local biome = realm.biome:getBiome(entity.transform.position)
                    if biome then
                        animator.setAssociation(
                            entity,
                            "elementalizer_" .. (BIOME_ELEMENTS:get(biome.type) or "empty")
                        )
                        local recipe = BIOME_RECIPES:get(biome.type)
                        if recipe ~= nil then
                            entity.fabricator.recipe = recipe
                        end
                    end
                end
            )
        end
    )
})
prefab:addFabricator({speed = 1, site = CraftSite.Elementalizer, canChangeRecipe = false})
prefab:addDispenser({frequency = 500})
prefab:addConsumer({idlePower = 25, activePower = 100})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay()
return ____exports
