local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 3,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 6,["19"] = 6,["20"] = 7,["21"] = 7,["22"] = 8,["23"] = 8,["24"] = 9,["25"] = 9,["26"] = 12,["27"] = 14,["28"] = 16,["29"] = 20,["30"] = 25,["31"] = 27,["32"] = 33,["33"] = 34,["34"] = 34,["35"] = 37,["36"] = 37,["37"] = 37,["38"] = 37,["39"] = 37,["40"] = 37,["41"] = 37,["42"] = 37,["43"] = 34,["44"] = 33,["45"] = 41,["46"] = 45,["47"] = 45,["48"] = 47,["49"] = 47,["50"] = 47,["51"] = 45,["52"] = 48,["53"] = 49,["54"] = 49,["55"] = 50,["56"] = 50,["57"] = 50,["58"] = 49,["59"] = 45,["60"] = 45,["61"] = 55,["62"] = 57,["63"] = 58,["64"] = 59,["65"] = 59,["66"] = 59,["67"] = 59,["68"] = 57,["69"] = 62,["70"] = 63,["71"] = 63,["72"] = 63,["73"] = 64,["74"] = 63,["75"] = 62,["76"] = 66,["77"] = 66,["78"] = 66,["79"] = 67,["80"] = 68,["81"] = 69,["82"] = 70,["83"] = 71,["84"] = 72,["86"] = 66,["87"] = 62,["88"] = 75,["89"] = 75,["90"] = 75,["91"] = 76,["92"] = 75,["93"] = 62,["94"] = 62,["95"] = 80,["96"] = 85,["97"] = 89,["98"] = 90,["99"] = 90,["100"] = 89,["101"] = 96,["102"] = 96,["103"] = 96,["104"] = 96,["105"] = 101,["106"] = 103,["107"] = 108,["108"] = 109,["109"] = 109,["110"] = 110,["111"] = 110,["112"] = 110,["113"] = 109,["114"] = 111,["115"] = 111,["116"] = 111,["117"] = 109,["118"] = 112,["119"] = 112,["120"] = 112,["121"] = 109,["122"] = 109,["123"] = 108,["124"] = 116});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____world = require("world")
local World = ____world.World
local ____craft = require("systems.craft")
local CraftManager = ____craft.CraftManager
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_infuser", stack = 20})
prefab:addRender("infuser_left10-1")
prefab:addAnimation({association = "infuser_left10", start = "idle", loop = true})
prefab:addInventory({inventories = {
    {name = "input-0", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {name = "input-1", size = 1, filterPrefabs = {INVALID_ENTITYID}},
    {
        name = "output",
        size = 1,
        filterPrefabs = {INVALID_ENTITYID},
        features = bit.bor(
            bit.bor(InventoryFeatures.Dispense, InventoryFeatures.Withdraw),
            InventoryFeatures.RecipeFlush
        )
    }
}})
prefab:addCollector({reach = 2})
prefab:addPlacement({
    drop = Prefab.getID("structure.infuser"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 3),
            "infuser_left10-1"
        )}
    )}
})
local DIRECTION_STRINGS = {"up", "left", "down", "right"}
local function updateAssocation(self, entity, recipe)
    local direction = DIRECTION_STRINGS[entity.placement.direction + 1]
    animator.setAssociation(
        entity,
        (("infuser_" .. direction) .. tostring(#recipe.fluids)) .. tostring(#recipe.resultFluids)
    )
end
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "EnergyFabricator", entity)
        end
    ),
    rotate = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(player.location.realm)
            placementRotate(entity.placement, entity, realm)
            GameEvents.playerRotateItem:invoke(player, entity)
            local recipe = CraftManager.recipes:get(entity.fabricator.recipe)
            if recipe then
                updateAssocation(nil, entity, recipe)
            end
        end
    ),
    recipeChange = __TS__New(
        Event,
        function(entity, recipe)
            updateAssocation(nil, entity, recipe)
        end
    )
})
prefab:addFabricator({speed = 1, site = CraftSite.Infuser})
prefab:addDispenser({frequency = 500})
prefab:addFluidSink({inputs = {
    FluidIO.new(FluidType.None, TileDirection.Right, 100),
    FluidIO.new(FluidType.None, TileDirection.Right, 100)
}})
prefab:addFluidSource({
    capacity = 0,
    outputs = {FluidIO.new(FluidType.None, TileDirection.Right, 100)}
})
prefab:addOverlay()
prefab:addConsumer({idlePower = 40, activePower = 160})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, destroyOnDeath = false, onDeath = breakItem})
return ____exports
