local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 6,["16"] = 6,["17"] = 7,["18"] = 7,["19"] = 10,["20"] = 12,["21"] = 14,["22"] = 18,["23"] = 22,["24"] = 27,["25"] = 29,["26"] = 31,["27"] = 36,["28"] = 40,["29"] = 42,["30"] = 42,["31"] = 42,["32"] = 42,["33"] = 42,["34"] = 42,["35"] = 42,["36"] = 42,["37"] = 40,["38"] = 46,["39"] = 50,["40"] = 50,["41"] = 52,["42"] = 53,["43"] = 53,["44"] = 53,["45"] = 53,["46"] = 53,["47"] = 53,["48"] = 50,["49"] = 50,["50"] = 57,["51"] = 58,["52"] = 58,["53"] = 59,["54"] = 58,["55"] = 57,["56"] = 63,["57"] = 63,["58"] = 63,["59"] = 63,["60"] = 68,["61"] = 68,["62"] = 68,["63"] = 68,["64"] = 72,["65"] = 73,["68"] = 75,["69"] = 76,["70"] = 77,["71"] = 78,["72"] = 79,["73"] = 80,["74"] = 81,["76"] = 83,["77"] = 84,["78"] = 85,["79"] = 86,["81"] = 68,["82"] = 68,["83"] = 91,["84"] = 97,["85"] = 103,["86"] = 104,["87"] = 104,["88"] = 105,["89"] = 105,["90"] = 105,["91"] = 104,["92"] = 106,["93"] = 106,["94"] = 106,["95"] = 104,["96"] = 107,["97"] = 107,["98"] = 107,["99"] = 104,["100"] = 108,["101"] = 108,["102"] = 108,["103"] = 104,["104"] = 104,["105"] = 103,["106"] = 112,["107"] = 119,["108"] = 123,["109"] = 123,["110"] = 125,["111"] = 126,["112"] = 127,["114"] = 129,["116"] = 123,["117"] = 123});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____mechanical = require("components.mechanical")
local MechanicalNodeType = ____mechanical.MechanicalNodeType
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addInventory({inventories = {}})
prefab:addItem({icon = "icons_power_chamber", stack = 20})
prefab:addRender("power_chamber-1")
prefab:addIllumination(1)
prefab:addAnimation({start = "idle", loop = true})
prefab:addAmbience({sfx = "event:/FABRICATORS/POWER_CHAMBER_LOOP"})
prefab:addInventory({inventories = {{
    name = "fuel",
    size = 1,
    filterCategories = {"fuel"},
    collectStack = 5,
    features = bit.bor(
        bit.bor(InventoryFeatures.Collect, InventoryFeatures.Deposit),
        InventoryFeatures.Withdraw
    )
}}})
prefab:addCollector({reach = 1})
prefab:addPlacement({
    drop = Prefab.getID("structure.power_chamber"),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(2, 3),
            "power_chamber.idle"
        )}
    )}
})
prefab:addEvent({interact = __TS__New(
    Event,
    function(player, entity)
        showModularDialogWithInventory(nil, "PowerChamber", entity)
    end
)})
prefab:addLight({
    intensity = 200,
    color = Color.new(100, 220, 255)
})
prefab:addConsumer({
    isAutonomous = true,
    idlePower = 10,
    activePower = 10,
    onStateChange = function(entityID, state, flag)
        if flag ~= ConsumerState.Powered then
            return
        end
        local entity = EntityManager.get(entityID)
        local producer = entity.producer
        if bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
            entity.consumer:addState(ConsumerState.Running)
            animator.tryPlay(entity, "running", true)
            producer.generate = producer.throughput
            entity.ambience.event:start()
        else
            entity.consumer:removeState(ConsumerState.Running)
            animator.tryPlay(entity, "idle", true)
            producer.generate = 0
            entity.ambience.event:stop(FMODStopMode.FMOD_STUDIO_STOP_ALLOWFADEOUT)
        end
    end
})
prefab:addDistributor({area = 0, range = 0, animate = false})
prefab:addProducer({generate = 0, throughput = 120, capacity = 0})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
prefab:addOverlay({noPowerIndicator = atlases.get("autoforge_window_no_fuel")})
prefab:addMechanical({
    inputs = {MechanicalNodeType.Basic},
    onReceive = function(____, mechanical, output, input, connection)
        if connection.signal.strength == 1 then
            input.consumer:addState(ConsumerState.On)
        else
            input.consumer:removeState(ConsumerState.On)
        end
    end
})
return ____exports
