local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 6,["19"] = 6,["20"] = 7,["21"] = 7,["22"] = 8,["23"] = 8,["24"] = 11,["25"] = 13,["26"] = 15,["27"] = 19,["28"] = 24,["29"] = 26,["30"] = 33,["31"] = 40,["32"] = 44,["33"] = 44,["34"] = 44,["35"] = 44,["36"] = 49,["37"] = 49,["38"] = 51,["39"] = 51,["40"] = 51,["41"] = 49,["42"] = 52,["43"] = 53,["44"] = 53,["45"] = 54,["46"] = 54,["47"] = 54,["48"] = 53,["49"] = 49,["50"] = 49,["51"] = 59,["52"] = 61,["53"] = 62,["54"] = 62,["55"] = 62,["56"] = 63,["57"] = 62,["58"] = 61,["59"] = 65,["60"] = 65,["61"] = 65,["62"] = 66,["63"] = 67,["64"] = 68,["65"] = 69,["66"] = 70,["67"] = 65,["68"] = 61,["69"] = 61,["70"] = 74,["71"] = 81,["72"] = 81,["73"] = 81,["74"] = 81,["75"] = 85,["76"] = 86,["79"] = 88,["80"] = 89,["81"] = 90,["82"] = 91,["83"] = 92,["85"] = 94,["86"] = 95,["88"] = 81,["89"] = 81,["90"] = 100,["91"] = 106,["92"] = 112,["93"] = 113,["94"] = 113,["95"] = 114,["96"] = 114,["97"] = 114,["98"] = 113,["99"] = 115,["100"] = 115,["101"] = 115,["102"] = 113,["103"] = 116,["104"] = 116,["105"] = 116,["106"] = 113,["107"] = 117,["108"] = 117,["109"] = 117,["110"] = 113,["111"] = 113,["112"] = 112,["113"] = 121});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____craft = require("craft")
local CraftSite = ____craft.CraftSite
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____utility = require("utility")
local breakItem = ____utility.breakItem
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addItem({icon = "icons_reactor", stack = 20})
prefab:addRender("reactor_left-1")
prefab:addAnimation({association = "reactor_left", start = "idle", loop = true})
prefab:addInventory({inventories = {{name = "", size = 0}, {name = "output", size = 0}}})
prefab:addFluidSink({inputs = {FluidIO.new(FluidType.Aether, TileDirection.Right, 500)}})
prefab:addFluidSource({
    capacity = 0,
    outputs = {FluidIO.new(FluidType.Miasma, TileDirection.Right, 500)}
})
prefab:addPlacement({
    drop = Prefab.getID("structure.reactor"),
    features = bit.bor(
        bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
        PlacementFeatures.ScaffoldingSupport
    ),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(3, 4),
            "reactor_left.idle"
        )}
    )}
})
local DIRECTION_STRINGS = {"left", "right", "left", "right"}
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "Reactor", entity)
        end
    ),
    rotate = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(player.location.realm)
            placementRotate(entity.placement, entity, realm)
            GameEvents.playerRotateItem:invoke(player, entity)
            local direction = DIRECTION_STRINGS[entity.placement.direction + 1]
            animator.setAssociation(entity, "reactor_" .. direction)
        end
    )
})
prefab:addFabricator({speed = 1, site = CraftSite.Byproduct, recipe = "ReactorByproduct", canChangeRecipe = false})
prefab:addConsumer({
    isAutonomous = true,
    idlePower = 0,
    activePower = 50,
    onStateChange = function(entityID, state, flag)
        if flag ~= ConsumerState.Powered then
            return
        end
        local entity = EntityManager.get(entityID)
        local producer = entity.producer
        if bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
            animator.tryPlay(entity, "running", true)
            producer.generate = producer.throughput
        else
            animator.tryPlay(entity, "idle", true)
            producer.generate = 0
        end
    end
})
prefab:addDistributor({area = 0, range = 0, animate = false})
prefab:addProducer({generate = 0, throughput = 800, capacity = 0})
prefab:addStats({stats = __TS__New(
    Map,
    {
        {
            "HP",
            Stat.new(30, 99, 30)
        },
        {
            "DEF",
            Stat.new(1, 99, 1)
        },
        {
            "NRG",
            Stat.new(1, 999999999, 0)
        },
        {
            "owner",
            Stat.new(0, 999999)
        }
    }
)})
prefab:addCombat({team = CombatTeam.Structure, priority = CombatPriority.High, destroyOnDeath = false, onDeath = breakItem})
return ____exports
