local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 2,["9"] = 2,["10"] = 3,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 6,["18"] = 6,["19"] = 8,["20"] = 10,["21"] = 12,["22"] = 16,["23"] = 18,["24"] = 20,["25"] = 21,["26"] = 21,["27"] = 21,["28"] = 20,["29"] = 20,["30"] = 20,["31"] = 28,["32"] = 28,["33"] = 30,["34"] = 30,["35"] = 30,["36"] = 28,["37"] = 28,["38"] = 36,["39"] = 41,["40"] = 41,["41"] = 41,["42"] = 44,["43"] = 45,["44"] = 45,["45"] = 45,["46"] = 45,["47"] = 45,["48"] = 45,["49"] = 41,["50"] = 41,["51"] = 49,["52"] = 50,["53"] = 50,["54"] = 50,["55"] = 50,["56"] = 50,["57"] = 50,["58"] = 50,["59"] = 52,["60"] = 53,["61"] = 54,["62"] = 55,["63"] = 57,["64"] = 58,["65"] = 59,["66"] = 59,["67"] = 59,["68"] = 59,["69"] = 59,["70"] = 52,["71"] = 62,["72"] = 63,["73"] = 63,["74"] = 63,["75"] = 64,["76"] = 63,["77"] = 62,["78"] = 66,["79"] = 66,["80"] = 66,["81"] = 67,["82"] = 68,["83"] = 69,["84"] = 70,["85"] = 66,["86"] = 62,["87"] = 72,["88"] = 72,["89"] = 72,["90"] = 73,["91"] = 72,["92"] = 62,["93"] = 62,["94"] = 77,["95"] = 78,["96"] = 79,["97"] = 80,["98"] = 81,["99"] = 82,["100"] = 83,["101"] = 83,["102"] = 83,["103"] = 83,["104"] = 83,["105"] = 79,["106"] = 77});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____direction = require("direction")
local FacingDirection = ____direction.FacingDirection
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____placement = require("utility.placement")
local placementRotate = ____placement.placementRotate
local ____base = require("ui.base")
local showModularDialogWithInventory = ____base.showModularDialogWithInventory
local ____world = require("world")
local World = ____world.World
local prefab = Prefab.getCurrent()
prefab:addTransform()
prefab:addLocation({layer = LayerTypes.Item})
prefab:addRender("storage_tank_water_left-1")
prefab:addAnimation({})
prefab:addFluidSink({
    inputs = {
        FluidIO.new(FluidType.Water, TileDirection.Right, 200),
        FluidIO.new(FluidType.Water, TileDirection.Right, 200)
    },
    transferToSource = true
})
prefab:addFluidSource({
    capacity = 20000,
    outputs = {
        FluidIO.new(FluidType.Water, TileDirection.Right, 200),
        FluidIO.new(FluidType.Water, TileDirection.Right, 200)
    }
})
prefab:addItem({icon = "icons_storage_tank", stack = 10})
prefab:addPlacement({
    drop = Prefab.getID("structure.storage_tank"),
    features = bit.bor(PlacementFeatures.Default, PlacementFeatures.Pivotable),
    axes = {PlacementAxis.new(
        PlacementAxisType.Floor,
        {PlacementDirection.new(
            FacingDirection.Right,
            TileVector.new(4, 4),
            "storage_tank_water_left-1"
        )}
    )}
})
local DIRECTION_STRINGS = {"up", "right", "down", "left"}
local FLUID_STRINGS = {
    "",
    "water",
    "lava",
    "miasma",
    "aether"
}
local function updateAssocation(self, entity)
    local fluid = FLUID_STRINGS[entity.fluidSource.outputs[1].type + 1]
    local direction = DIRECTION_STRINGS[entity.placement.direction + 1]
    animator.setAssociation(entity, (("storage_tank_" .. fluid) .. "_") .. direction)
    local source = entity.fluidSource
    local currentLevel = math.ceil(source.quantity / source.capacity * 10)
    animator.tryPlay(
        entity,
        tostring(currentLevel),
        false
    )
end
prefab:addEvent({
    interact = __TS__New(
        Event,
        function(player, entity)
            showModularDialogWithInventory(nil, "StorageTank", entity)
        end
    ),
    rotate = __TS__New(
        Event,
        function(player, entity)
            local realm = World:get(player.location.realm)
            placementRotate(entity.placement, entity, realm)
            GameEvents.playerRotateItem:invoke(player, entity)
            updateAssocation(nil, entity)
        end
    ),
    fluidChange = __TS__New(
        Event,
        function(entity)
            updateAssocation(nil, entity)
        end
    )
})
prefab.onCreate:listen(function(entity)
    local entityID = entity.id
    entity.fluidSource.onQuantityChanged:listen(function(____, index)
        local entity = EntityManager.get(entityID)
        local source = entity.fluidSource
        local currentLevel = math.ceil(source.quantity / source.capacity * 10)
        animator.tryPlay(
            entity,
            tostring(currentLevel),
            false
        )
    end)
end)
return ____exports
