local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local Set = ____lualib.Set
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__ArrayFilter = ____lualib.__TS__ArrayFilter
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["12"] = 2,["13"] = 2,["14"] = 3,["15"] = 3,["16"] = 4,["17"] = 4,["18"] = 5,["19"] = 5,["20"] = 18,["21"] = 18,["22"] = 18,["24"] = 18,["25"] = 19,["26"] = 18,["27"] = 21,["28"] = 21,["29"] = 21,["30"] = 22,["31"] = 23,["32"] = 24,["33"] = 25,["34"] = 26,["35"] = 27,["36"] = 28,["38"] = 30,["39"] = 31,["41"] = 33,["42"] = 33,["43"] = 33,["44"] = 33,["46"] = 36,["47"] = 37,["48"] = 38,["49"] = 40,["50"] = 41,["51"] = 22,["52"] = 44,["53"] = 45,["54"] = 44,["55"] = 48,["56"] = 49,["57"] = 50,["58"] = 48,["59"] = 53,["60"] = 54,["61"] = 53,["62"] = 57,["63"] = 58,["64"] = 59,["65"] = 60,["68"] = 64,["69"] = 66,["70"] = 67,["71"] = 68,["73"] = 70,["76"] = 74,["77"] = 75,["78"] = 76,["81"] = 80,["82"] = 81,["83"] = 82,["84"] = 83,["88"] = 88,["89"] = 89,["90"] = 57,["91"] = 92,["92"] = 93,["93"] = 94,["94"] = 95,["97"] = 99,["98"] = 102,["99"] = 103,["100"] = 104,["102"] = 107,["103"] = 110,["104"] = 111,["105"] = 112,["106"] = 113,["109"] = 117,["110"] = 118,["111"] = 92,["112"] = 121,["113"] = 122,["114"] = 123,["115"] = 124,["118"] = 128,["119"] = 131,["120"] = 132,["122"] = 136,["123"] = 137,["124"] = 138,["126"] = 141,["127"] = 144,["128"] = 145,["129"] = 146,["130"] = 147,["132"] = 150,["133"] = 151,["136"] = 155,["137"] = 156,["138"] = 157,["141"] = 161,["142"] = 162,["143"] = 121,["144"] = 165,["145"] = 166,["146"] = 167,["147"] = 168,["150"] = 172,["151"] = 172,["152"] = 173,["153"] = 174,["154"] = 175,["155"] = 176,["156"] = 177,["158"] = 179,["160"] = 172,["161"] = 185,["162"] = 186,["163"] = 187,["164"] = 188,["165"] = 190,["166"] = 191,["167"] = 192,["168"] = 193,["169"] = 194,["173"] = 199,["174"] = 165,["175"] = 202,["176"] = 203,["177"] = 204,["178"] = 205,["181"] = 209,["182"] = 210,["183"] = 211,["184"] = 212,["185"] = 213,["186"] = 214,["187"] = 215,["188"] = 216,["191"] = 218,["192"] = 219,["193"] = 220,["194"] = 221,["196"] = 224,["197"] = 202,["198"] = 227,["199"] = 228,["200"] = 229,["201"] = 229,["203"] = 231,["204"] = 233,["205"] = 234,["206"] = 235,["207"] = 237,["208"] = 238,["209"] = 240,["210"] = 241,["211"] = 242,["212"] = 243,["213"] = 244,["214"] = 245,["216"] = 247,["217"] = 248,["218"] = 249,["221"] = 253,["222"] = 254,["223"] = 255,["225"] = 258,["226"] = 259,["227"] = 259,["228"] = 259,["229"] = 259,["230"] = 259,["231"] = 258,["232"] = 260,["233"] = 260,["234"] = 260,["235"] = 260,["236"] = 260,["237"] = 258,["238"] = 258,["239"] = 258,["240"] = 258,["241"] = 258,["242"] = 266,["243"] = 227,["244"] = 270});
local ____exports = {}
local ____craft = require("systems.craft")
local CraftManager = ____craft.CraftManager
local ____technology = require("systems.technology")
local TechnologyManager = ____technology.TechnologyManager
local ____utility = require("utility")
local getTimeString = ____utility.getTimeString
local ____scene = require("scenes.scene")
local Scene = ____scene.Scene
local Graphs = __TS__Class()
Graphs.name = "Graphs"
__TS__ClassExtends(Graphs, Scene)
function Graphs.prototype.____constructor(self, ...)
    Scene.prototype.____constructor(self, ...)
    self.recipes = __TS__New(Map)
end
function Graphs.create(self)
    return __TS__New(Graphs)
end
function Graphs.prototype.activate(self, data)
    local materials = __TS__New(Set)
    local produced = __TS__New(Set)
    for ____, recipe in __TS__Iterator(CraftManager.recipes) do
        log.info("Recipe: " .. recipe[2].name)
        for ____, material in ipairs(recipe[2].materials) do
            materials:add(material.prefab)
        end
        for ____, result in ipairs(recipe[2].result) do
            produced:add(result.prefab)
        end
        self.recipes:set(
            recipe[1],
            self:getRecipeData(recipe[1])
        )
    end
    self:graphRecipes(materials, produced)
    self:graphTechnologies(materials, produced)
    self:graphTechTree(materials, produced)
    self:outputTechnologyRedundancies()
    self:outputRecipeData()
end
function Graphs.prototype.update(self, frameTime)
    _G.isRunning = false
end
function Graphs.prototype.writeHeader(self, file)
    file:write("```mermaid\n")
    file:write("graph LR\n")
end
function Graphs.prototype.writeFooter(self, file)
    file:write("```")
end
function Graphs.prototype.graphRecipes(self, materials, produced)
    local file, errmsg = io.open("data\\graphs\\recipes.md", "w")
    if file == nil then
        log.info("Failed to open recipes.md: " .. tostring(errmsg))
        return
    end
    self:writeHeader(file)
    for ____, material in __TS__Iterator(materials) do
        if produced:has(material) then
            file:write(((("    " .. material) .. "(") .. material) .. ")\n")
        else
            file:write(((("    " .. material) .. "[[") .. material) .. "]]\n")
        end
    end
    for ____, item in __TS__Iterator(produced) do
        if not materials:has(item) then
            file:write(((("    " .. item) .. "[(") .. item) .. ")]\n")
        end
    end
    for ____, recipe in __TS__Iterator(CraftManager.recipes) do
        for ____, material in ipairs(recipe[2].materials) do
            for ____, result in ipairs(recipe[2].result) do
                file:write(((("    " .. material.prefab) .. " --> ") .. result.prefab) .. "\n")
            end
        end
    end
    self:writeFooter(file)
    file:close()
end
function Graphs.prototype.graphTechTree(self, materials, produced)
    local file, errmsg = io.open("data\\graphs\\tech_tree.md", "w")
    if file == nil then
        log.info("Failed to open tech_tree.md: " .. tostring(errmsg))
        return
    end
    self:writeHeader(file)
    for ____, research in __TS__Iterator(TechnologyManager.technologies) do
        local technology = research[2]
        file:write(((("    T" .. tostring(technology.id)) .. "{{") .. technology.name) .. " Tech}}\n")
    end
    file:write("    TStarting{{Starting}}\n")
    for ____, research in __TS__Iterator(TechnologyManager.technologies) do
        local technology = research[2]
        for ____, dependency in __TS__Iterator(technology.dependencies) do
            file:write(((("    T" .. tostring(dependency)) .. " ==> T") .. tostring(technology.id)) .. "\n")
        end
    end
    self:writeFooter(file)
    file:close()
end
function Graphs.prototype.graphTechnologies(self, materials, produced)
    local file, errmsg = io.open("data\\graphs\\technologies.md", "w")
    if file == nil then
        log.info("Failed to open technologies.md: " .. tostring(errmsg))
        return
    end
    self:writeHeader(file)
    for ____, recipe in __TS__Iterator(CraftManager.recipes) do
        file:write(((("    R" .. recipe[2].name) .. "((") .. recipe[2].name) .. "))\n")
    end
    for ____, research in __TS__Iterator(TechnologyManager.technologies) do
        local technology = research[2]
        file:write(((("    T" .. tostring(technology.id)) .. "{{") .. technology.name) .. " Tech}}\n")
    end
    file:write("    TStarting{{Starting}}\n")
    for ____, research in __TS__Iterator(TechnologyManager.technologies) do
        local technology = research[2]
        for ____, dependency in __TS__Iterator(technology.dependencies) do
            file:write(((("    T" .. tostring(dependency)) .. " ==> T") .. tostring(technology.id)) .. "\n")
        end
        for ____, recipe in ipairs(technology.learned) do
            file:write(((("    T" .. tostring(technology.id)) .. " --> R") .. recipe) .. "\n")
        end
    end
    for ____, recipe in __TS__Iterator(CraftManager.recipes) do
        if recipe[2].known then
            file:write(("    TStarting --> R" .. recipe[2].name) .. "\n")
        end
    end
    self:writeFooter(file)
    file:close()
end
function Graphs.prototype.outputTechnologyRedundancies(self)
    local file, errmsg = io.open("data\\graphs\\tech_redundancies.md", "w")
    if file == nil then
        log.info("Failed to open tech_redundancies.md: " .. tostring(errmsg))
        return
    end
    local addDependencies
    addDependencies = function(self, technologies, dependencies, path)
        for ____, technologyID in __TS__Iterator(technologies) do
            local technology = TechnologyManager:get(technologyID)
            local techPath = path ~= "" and (technology.name .. " => ") .. path or technology.name
            for ____, dependency in __TS__Iterator(technology.dependencies) do
                dependencies:set(dependency, techPath)
            end
            addDependencies(nil, technology.dependencies, dependencies, techPath)
        end
    end
    for ____, technology in __TS__Iterator(TechnologyManager.technologies) do
        local dependencies = technology[2].dependencies
        local allDependencies = __TS__New(Map)
        addDependencies(nil, dependencies, allDependencies, "")
        for ____, dependency in __TS__Iterator(dependencies) do
            if allDependencies:has(dependency) then
                file:write(("## " .. locale.get(technology[2].name .. "Tech")) .. "\n")
                file:write((TechnologyManager:get(dependency).name .. "Tech") .. "\n")
                file:write(tostring(allDependencies:get(dependency)) .. "\n\n")
            end
        end
    end
    file:close()
end
function Graphs.prototype.outputRecipeData(self)
    local file, errmsg = io.open("data\\graphs\\recipe_data.md", "w")
    if file == nil then
        log.info("Failed to open recipe_data.md: " .. tostring(errmsg))
        return
    end
    for ____, recipe in __TS__Iterator(self.recipes) do
        file:write(("## " .. locale.get(recipe[1] .. "Name")) .. "\n")
        file:write("### Raw Materials\n")
        local data = recipe[2]
        local items = #data.rawest > 0 and data.rawest or data.raw
        for ____, item in ipairs(items) do
            if not item:isEmpty() then
                file:write(((("- " .. locale.get(item.prefab .. "Name")) .. " x") .. tostring(item.quantity)) .. "\n")
            end
        end
        file:write("### Data\n")
        file:write(("- total: " .. getTimeString(nil, data.total)) .. "\n")
        file:write(("- biofuel: " .. tostring(data.biofuel)) .. "\n")
        file:write(("- power: " .. tostring(data.power)) .. "\n\n")
    end
    file:close()
end
function Graphs.prototype.getRecipeData(self, name)
    local data = self.recipes:get(name)
    if data then
        return data
    end
    local recipe = CraftManager.recipes:get(name)
    local raw = Inventory.new({size = 50, stackOverride = 1000})
    local rawest = Inventory.new({size = 50, stackOverride = 1000})
    local total = recipe.time
    local biofuel = 0
    local power = 0
    for ____, item in ipairs(recipe.materials) do
        local recipeName = CraftManager.results:get(item.entityID)
        if recipeName then
            local dependent = self:getRecipeData(recipeName)
            for ____, rawItem in ipairs(dependent.raw) do
                raw:add(Item.new(rawItem.entityID, rawItem.quantity * item.quantity))
            end
            total = total + dependent.total * item.quantity
            biofuel = biofuel + dependent.biofuel
            power = power + dependent.power
        end
    end
    if raw:isEmpty() then
        raw:addAll(recipe.result)
        rawest:addAll(recipe.materials)
    end
    data = {
        raw = __TS__ArrayFilter(
            raw.items,
            function(____, value)
                return not value:isEmpty()
            end
        ),
        rawest = __TS__ArrayFilter(
            rawest.items,
            function(____, value)
                return not value:isEmpty()
            end
        ),
        total = total,
        biofuel = biofuel,
        power = power
    }
    return data
end
____exports.scene = Graphs
return ____exports
