local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local Set = ____lualib.Set
local Map = ____lualib.Map
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__ArrayConcat = ____lualib.__TS__ArrayConcat
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["11"] = 2,["12"] = 2,["13"] = 2,["14"] = 3,["15"] = 3,["16"] = 3,["17"] = 4,["18"] = 4,["19"] = 6,["20"] = 8,["21"] = 8,["22"] = 18,["23"] = 9,["24"] = 13,["25"] = 15,["26"] = 16,["27"] = 19,["28"] = 20,["29"] = 21,["30"] = 22,["31"] = 23,["33"] = 25,["34"] = 26,["35"] = 26,["36"] = 18,["37"] = 33,["38"] = 33,["40"] = 34,["41"] = 35,["42"] = 36,["43"] = 33,["44"] = 38,["45"] = 39,["46"] = 39,["47"] = 39,["48"] = 39,["49"] = 38,["50"] = 42,["51"] = 43,["52"] = 42,["53"] = 46,["54"] = 47,["55"] = 46,["56"] = 50,["57"] = 51,["58"] = 53,["59"] = 50,["60"] = 56,["61"] = 57,["62"] = 58,["64"] = 56,["65"] = 62,["66"] = 63,["67"] = 64,["69"] = 67,["70"] = 68,["71"] = 69,["72"] = 70,["73"] = 71,["77"] = 76,["78"] = 62,["79"] = 79,["80"] = 80,["81"] = 79,["82"] = 83,["83"] = 84,["84"] = 85,["85"] = 86,["87"] = 89,["88"] = 90,["89"] = 90,["90"] = 90,["91"] = 90,["92"] = 91,["93"] = 92,["95"] = 95,["96"] = 96,["98"] = 98,["99"] = 100,["100"] = 101,["101"] = 102,["102"] = 83,["103"] = 108,["104"] = 109,["105"] = 111,["106"] = 113,["107"] = 116,["108"] = 117,["110"] = 120,["111"] = 121,["112"] = 122,["113"] = 123,["114"] = 124,["118"] = 129,["120"] = 132,["121"] = 133,["122"] = 133,["123"] = 133});
local ____exports = {}
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____upgrades = require("upgrades")
local UpgradeType = ____upgrades.UpgradeType
local addUpgrades = ____upgrades.addUpgrades
local ____upgrades = require("utility.upgrades")
local setupUpgrades = ____upgrades.setupUpgrades
GameEvents.upgradeUnlocked = __TS__New(Event)
local UpgradeItem = __TS__Class()
UpgradeItem.name = "UpgradeItem"
function UpgradeItem.prototype.____constructor(self, upgrade)
    self.type = UpgradeType.None
    self.connections = __TS__New(Set)
    self.activateOnLoad = false
    self.materials = {}
    self.type = upgrade.type
    self.name = upgrade.name
    self.position = upgrade.position
    for ____, connection in ipairs(upgrade.connections) do
        self.connections:add(connection)
    end
    self.icon = atlases.get(("upgrade_icons_" .. string.lower(self.name)) .. "_active")
    local ____self_materials_0 = self.materials
    ____self_materials_0[#____self_materials_0 + 1] = Item.create("material.ancient_tech")
end
local ArmoryManager = __TS__Class()
ArmoryManager.name = "ArmoryManager"
function ArmoryManager.prototype.____constructor(self)
    self.upgrades = __TS__New(Map)
    self.upgradePositions = {}
    self.costs = {}
end
function ArmoryManager.prototype.add(self, upgrade)
    self.upgrades:set(
        upgrade.type,
        __TS__New(UpgradeItem, upgrade)
    )
end
function ArmoryManager.prototype.get(self, ____type)
    return self.upgrades:get(____type)
end
function ArmoryManager.prototype.getAt(self, position)
    return self:get(self.upgradePositions[position + 1])
end
function ArmoryManager.prototype.getCost(self, component)
    local count = component.upgrades.size
    return {}
end
function ArmoryManager.prototype.setup(self, upgrades, activation)
    for ____, upgradeType in ipairs(upgrades) do
        self:get(upgradeType).activate = activation
    end
end
function ArmoryManager.prototype.isAvailable(self, ____type, component)
    if component.upgrades:has(____type) then
        return false
    end
    if component.upgrades.size > 0 then
        local upgrade = self:get(____type)
        for ____, connection in __TS__Iterator(upgrade.connections) do
            if component.upgrades:has(self.upgradePositions[connection + 1]) then
                return true
            end
        end
    end
    return ____type == UpgradeType.EMPOWER
end
function ArmoryManager.prototype.canUnlock(self, ____type, component, inventory)
    return self:isAvailable(____type, component) and inventory:hasAll(self:get(____type).materials)
end
function ArmoryManager.prototype.unlock(self, ____type, entity, inventory)
    local component = entity.armory
    if not self:canUnlock(____type, component, inventory) then
        return false
    end
    local upgrade = self:get(____type)
    local cost = __TS__ArrayConcat(
        self:getCost(component),
        upgrade.materials
    )
    for ____, item in ipairs(cost) do
        inventory:remove(item)
    end
    if upgrade.activate ~= nil then
        upgrade:activate(entity)
    end
    component.upgrades:add(____type)
    component.onUpgrade:invoke(entity, upgrade.type)
    GameEvents.upgradeUnlocked:invoke(entity, upgrade)
    return true
end
if _G.ArmoryManager == nil then
    _G.ArmoryManager = __TS__New(ArmoryManager)
    local manager = _G.ArmoryManager
    addUpgrades(nil, manager)
    for ____, upgrade in __TS__Iterator(manager.upgrades) do
        manager.upgradePositions[upgrade[2].position + 1] = upgrade[1]
    end
    for ____, upgrade in __TS__Iterator(manager.upgrades) do
        for ____, connect in __TS__Iterator(upgrade[2].connections) do
            local connectedUpgrade = manager:getAt(connect)
            if connectedUpgrade ~= nil then
                connectedUpgrade.connections:add(upgrade[2].position)
            end
        end
    end
    setupUpgrades(nil, manager)
end
local manager = _G.ArmoryManager
____exports.ArmoryManager = manager
____exports.ArmoryManagerType = ArmoryManager
____exports.UpgradeItem = UpgradeItem
return ____exports
