local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 2,["13"] = 2,["14"] = 4,["15"] = 5,["16"] = 7,["17"] = 7,["18"] = 7,["20"] = 7,["21"] = 11,["22"] = 7,["23"] = 13,["24"] = 13,["25"] = 15,["26"] = 16,["29"] = 7,["30"] = 19,["31"] = 20,["33"] = 22,["34"] = 23,["35"] = 24,["36"] = 25,["39"] = 28,["40"] = 29,["41"] = 30,["43"] = 33,["44"] = 15,["45"] = 36,["46"] = 37,["47"] = 7,["48"] = 39,["50"] = 36,["51"] = 43,["52"] = 45,["53"] = 46,["54"] = 47,["56"] = 48,["57"] = 49,["58"] = 50,["59"] = 51,["60"] = 52,["61"] = 53,["62"] = 54,["63"] = 55,["64"] = 56,["65"] = 57,["66"] = 58,["67"] = 59,["69"] = 62,["70"] = 63,["71"] = 64,["72"] = 65,["73"] = 66,["74"] = 67,["75"] = 68,["76"] = 69,["77"] = 70,["78"] = 71,["79"] = 72,["80"] = 73,["82"] = 76,["83"] = 77,["84"] = 78,["85"] = 79,["87"] = 81,["88"] = 82,["89"] = 83,["92"] = 87,["93"] = 88,["97"] = 91,["98"] = 92,["100"] = 94,["101"] = 43,["102"] = 97,["103"] = 98,["106"] = 100,["107"] = 101,["108"] = 102,["109"] = 103,["111"] = 97,["112"] = 107,["113"] = 108,["114"] = 109,["115"] = 110,["116"] = 111,["118"] = 107,["119"] = 115,["120"] = 116,["121"] = 117,["123"] = 119,["125"] = 115,["126"] = 8,["127"] = 126,["128"] = 127,["129"] = 128,["130"] = 129,["131"] = 129,["132"] = 129,["133"] = 129,["134"] = 130,["136"] = 133,["137"] = 135});
local ____exports = {}
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local ____core = require("core")
local core = ____core.core
local FLUID_QUANTITY = 25
local FLUID_ENERGY = 100
local CombustSystem = __TS__Class()
CombustSystem.name = "CombustSystem"
__TS__ClassExtends(CombustSystem, EntitySystem)
function CombustSystem.prototype.____constructor(self, ...)
    EntitySystem.prototype.____constructor(self, ...)
    self._active = __TS__New(Set)
end
function CombustSystem.prototype.initialize(self)
end
function CombustSystem.prototype.add(self, entity, component)
    if not component.isAutonomous or entity.stats == nil or not entity.stats:has("NRG") then
        return
    end
    EntitySystem.prototype.add(self, entity, component)
    if entity.consumer.isOn then
        self._active:add(entity.id)
    end
    if entity.inventory ~= nil then
        local fuel = entity.inventory:get("fuel")
        if fuel ~= nil then
            fuel.onChange:listen(core.bind(self, "handleInventoryChange", entity.id))
        end
    end
    local sink = entity.fluidSink
    if sink ~= nil then
        sink.onQuantityChanged:listen(core.bind(self, "handleFluidChange", entity.id))
    end
    entity.consumer.onStateChange:listen(core.cb(self, "handleStateChange"))
end
function CombustSystem.prototype.remove(self, entity, component)
    if component.isAutonomous then
        EntitySystem.prototype.remove(self, entity, component)
        self._active:delete(entity.id)
    end
end
function CombustSystem.prototype.update(self, frameTime)
    tracy.ZoneBeginN("CombustSystem::update()")
    local removed = {}
    for ____, entityID in __TS__Iterator(self._active) do
        do
            local entity = EntityManager.get(entityID)
            local nrg = entity.stats:get("NRG")
            local consumer = entity.consumer
            if nrg:getCurrent() == 0 then
                local inventory = entity.inventory:get("fuel")
                local sink = entity.fluidSink
                if inventory ~= nil then
                    local index, item = inventory:first()
                    if index == -1 then
                        consumer:removeState(ConsumerState.Powered)
                        removed[#removed + 1] = entityID
                        goto __continue12
                    end
                    local amount = item:entity().fuel.amount
                    item.quantity = item.quantity - 1
                    inventory:changed(index, item)
                    nrg:set(amount)
                    nrg:setCurrent(amount)
                    consumer:addState(ConsumerState.Powered)
                elseif sink ~= nil then
                    local input = sink.inputs[1]
                    if input.quantity < FLUID_QUANTITY then
                        consumer:removeState(ConsumerState.Powered)
                        removed[#removed + 1] = entityID
                        goto __continue12
                    end
                    sink:setQuantity(0, input.quantity - FLUID_QUANTITY)
                    nrg:set(FLUID_ENERGY)
                    nrg:setCurrent(FLUID_ENERGY)
                    consumer:addState(ConsumerState.Powered)
                else
                    consumer:removeState(ConsumerState.Powered)
                    removed[#removed + 1] = entityID
                    goto __continue12
                end
            end
            local demand = consumer.demand * frameTime.seconds
            nrg:adjustCurrent(-demand)
        end
        ::__continue12::
    end
    for ____, entityID in ipairs(removed) do
        self._active:delete(entityID)
    end
    tracy.ZoneEnd()
end
function CombustSystem.prototype.handleInventoryChange(self, entityID, index)
    if self._active:has(entityID) then
        return
    end
    local entity = EntityManager.get(entityID)
    local item = entity.inventory:get("fuel").items[index + 1]
    if not item:isEmpty() then
        self._active:add(entityID)
    end
end
function CombustSystem.prototype.handleFluidChange(self, entityID, index)
    local entity = EntityManager.get(entityID)
    local sink = entity.fluidSink
    if sink.inputs[1].quantity >= FLUID_QUANTITY then
        self._active:add(entityID)
    end
end
function CombustSystem.prototype.handleStateChange(self, entityID, state, flag)
    if bit.band(state, ConsumerState.On) == ConsumerState.On then
        self._active:add(entityID)
    else
        self._active:delete(entityID)
    end
end
CombustSystem.ID = HashString("CombustSystem")
if _G.CombustSystem == nil then
    _G.CombustSystem = __TS__New(CombustSystem)
    SystemManager.registerSystem(CombustSystem.ID, _G.CombustSystem, 16)
    SystemManager.associate(
        CombustSystem.ID,
        hash.hash_str32("consumer")
    )
    log.info("Registering CombustSystem")
end
local manager = _G.CombustSystem
____exports.CombustSystem = manager
return ____exports
