local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local Set = ____lualib.Set
local __TS__New = ____lualib.__TS__New
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 2,["13"] = 2,["14"] = 3,["15"] = 3,["16"] = 4,["17"] = 4,["18"] = 5,["19"] = 5,["20"] = 8,["21"] = 8,["22"] = 8,["24"] = 8,["25"] = 12,["26"] = 8,["27"] = 14,["28"] = 14,["29"] = 16,["30"] = 17,["31"] = 16,["32"] = 20,["33"] = 8,["34"] = 22,["35"] = 23,["36"] = 24,["38"] = 25,["39"] = 20,["40"] = 28,["41"] = 8,["42"] = 30,["43"] = 28,["44"] = 33,["45"] = 34,["46"] = 35,["47"] = 36,["49"] = 37,["50"] = 38,["51"] = 39,["52"] = 39,["54"] = 41,["55"] = 42,["56"] = 43,["57"] = 44,["58"] = 45,["59"] = 47,["60"] = 48,["61"] = 49,["62"] = 50,["63"] = 51,["64"] = 52,["66"] = 54,["67"] = 54,["68"] = 54,["69"] = 54,["70"] = 54,["72"] = 57,["73"] = 58,["74"] = 59,["80"] = 63,["81"] = 64,["83"] = 66,["84"] = 33,["85"] = 69,["86"] = 70,["87"] = 71,["89"] = 69,["90"] = 9,["91"] = 78,["92"] = 79,["93"] = 80,["94"] = 81,["95"] = 81,["96"] = 81,["97"] = 81,["99"] = 84,["100"] = 86});
local ____exports = {}
local ____architect = require("architect")
local architect = ____architect.architect
local ____core = require("core")
local core = ____core.core
local ____direction = require("direction")
local getDirectionVector = ____direction.getDirectionVector
local ____world = require("world")
local World = ____world.World
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local DispenserSystem = __TS__Class()
DispenserSystem.name = "DispenserSystem"
__TS__ClassExtends(DispenserSystem, EntitySystem)
function DispenserSystem.prototype.____constructor(self, ...)
    EntitySystem.prototype.____constructor(self, ...)
    self._active = __TS__New(Set)
end
function DispenserSystem.prototype.initialize(self)
end
function DispenserSystem.prototype.reset(self)
    self._active:clear()
end
function DispenserSystem.prototype.add(self, entity, component)
    EntitySystem.prototype.add(self, entity, component)
    local output = entity.inventory:get("output")
    if not output:isEmpty() then
        self._active:add(entity.id)
    end
    output.onChange:listen(core.bind(self, "handleInventoryChange", entity.id))
end
function DispenserSystem.prototype.remove(self, entity, component)
    EntitySystem.prototype.remove(self, entity, component)
    self._active:delete(entity.id)
end
function DispenserSystem.prototype.update(self, frameTime)
    tracy.ZoneBeginN("DispenserSystem::update()")
    local empty = {}
    for ____, entityID in __TS__Iterator(self._active) do
        do
            local entity = EntityManager.get(entityID)
            local dispenser = entity.dispenser
            if not dispenser.isEnabled or not dispenser.timer:expired() then
                goto __continue8
            end
            local inventory = entity.inventory:get("output")
            local index, item = inventory:first()
            if index ~= -1 then
                local realmID = entity.location.realm
                local items = World:get(realmID).items
                local offset = getDirectionVector(nil, entity.placement.direction)
                local tilePosition = TileVector.new(dispenser.position.x + offset.x, dispenser.position.y + offset.y)
                if items:canPlaceItem(tilePosition) then
                    items:placeItem(tilePosition, item.entityID)
                    item.quantity = item.quantity - 1
                    inventory:changed(index, item)
                else
                    architect:transferInventoryItem(
                        realmID,
                        inventory,
                        tilePosition:asVector()
                    )
                end
                dispenser.timer:reset(dispenser.frequency)
                if inventory:isEmpty() then
                    empty[#empty + 1] = entityID
                end
            end
        end
        ::__continue8::
    end
    for ____, entityID in ipairs(empty) do
        self._active:delete(entityID)
    end
    tracy.ZoneEnd()
end
function DispenserSystem.prototype.handleInventoryChange(self, entityID, index, item)
    if not item:isEmpty() then
        self._active:add(entityID)
    end
end
DispenserSystem.ID = HashString("DispenserSystem")
if _G.DispenserSystem == nil then
    _G.DispenserSystem = __TS__New(DispenserSystem)
    SystemManager.registerSystem(DispenserSystem.ID, _G.DispenserSystem, 16)
    SystemManager.associate(
        DispenserSystem.ID,
        hash.hash_str32("dispenser")
    )
end
local manager = _G.DispenserSystem
____exports.DispenserSystem = manager
return ____exports
