local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local Map = ____lualib.Map
local __TS__Class = ____lualib.__TS__Class
local Set = ____lualib.Set
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 2,["13"] = 2,["14"] = 3,["15"] = 3,["16"] = 3,["17"] = 5,["18"] = 5,["19"] = 7,["20"] = 7,["21"] = 8,["22"] = 8,["23"] = 11,["24"] = 13,["25"] = 13,["26"] = 13,["27"] = 14,["28"] = 14,["29"] = 14,["30"] = 13,["31"] = 15,["32"] = 15,["33"] = 15,["34"] = 13,["35"] = 16,["36"] = 16,["37"] = 16,["38"] = 13,["39"] = 17,["40"] = 17,["41"] = 17,["42"] = 13,["43"] = 18,["44"] = 18,["45"] = 18,["46"] = 13,["47"] = 19,["48"] = 19,["49"] = 19,["50"] = 13,["51"] = 20,["52"] = 20,["53"] = 20,["54"] = 13,["55"] = 21,["56"] = 21,["57"] = 21,["58"] = 13,["59"] = 22,["60"] = 22,["61"] = 22,["62"] = 13,["63"] = 23,["64"] = 23,["65"] = 23,["66"] = 13,["67"] = 24,["68"] = 24,["69"] = 24,["70"] = 13,["71"] = 13,["72"] = 13,["73"] = 27,["74"] = 27,["75"] = 31,["76"] = 29,["77"] = 32,["78"] = 31,["79"] = 35,["80"] = 36,["81"] = 35,["82"] = 39,["83"] = 40,["84"] = 39,["85"] = 43,["86"] = 44,["87"] = 45,["88"] = 46,["89"] = 47,["90"] = 48,["91"] = 49,["92"] = 50,["93"] = 51,["97"] = 43,["98"] = 57,["99"] = 58,["100"] = 59,["101"] = 57,["102"] = 62,["103"] = 63,["104"] = 64,["105"] = 64,["106"] = 64,["107"] = 64,["109"] = 65,["110"] = 65,["111"] = 66,["112"] = 67,["113"] = 68,["114"] = 69,["115"] = 70,["117"] = 65,["120"] = 62,["121"] = 75,["122"] = 76,["123"] = 77,["124"] = 77,["125"] = 77,["126"] = 77,["128"] = 78,["129"] = 78,["130"] = 79,["131"] = 80,["132"] = 81,["133"] = 82,["134"] = 83,["136"] = 78,["139"] = 75,["140"] = 88,["141"] = 89,["142"] = 90,["143"] = 91,["144"] = 92,["145"] = 93,["146"] = 88,["147"] = 28,["148"] = 98});
local ____exports = {}
local ____location = require("components.location")
local LayerTypes = ____location.LayerTypes
local ____core = require("core")
local core = ____core.core
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
local ____Sizes = require("Sizes")
local Sizes = ____Sizes.Sizes
local ____world = require("world")
local World = ____world.World
local ____notification = require("systems.notification")
local NotificationSystem = ____notification.NotificationSystem
GameEvents.resourceDiscovered = __TS__New(Event)
local RESOURCE_INSIGHT_ANIMATION = __TS__New(
    Map,
    {
        {
            Prefab.getID("material.iron_ore"),
            "ore_sparkles.iron_ore"
        },
        {
            Prefab.getID("material.silver_ore"),
            "ore_sparkles.silver_ore"
        },
        {
            Prefab.getID("material.adamantite_ore"),
            "ore_sparkles.adamantite_ore"
        },
        {
            Prefab.getID("material.corium_ore"),
            "ore_sparkles.corium_ore"
        },
        {
            Prefab.getID("tile.mana_deposit"),
            "ore_sparkles.mana_deposit"
        },
        {
            Prefab.getID("tile.biomass_deposit"),
            "ore_sparkles.biomass_deposit"
        },
        {
            Prefab.getID("tile.stone_deposit"),
            "ore_sparkles.stone_deposit"
        },
        {
            Prefab.getID("tile.sandstone"),
            "ore_sparkles.sandstone_deposit"
        },
        {
            Prefab.getID("environment.lava_wellspring"),
            "ore_sparkles.lava_wellspring"
        },
        {
            Prefab.getID("environment.miasma_wellspring"),
            "ore_sparkles.miasma_wellspring"
        },
        {
            Prefab.getID("environment.water_wellspring"),
            "ore_sparkles.water_wellspring"
        }
    }
)
local IndicatorSystem = __TS__Class()
IndicatorSystem.name = "IndicatorSystem"
function IndicatorSystem.prototype.____constructor(self, realmID, backwall)
    self.entities = __TS__New(Set)
    backwall.onHarvest:listen(core.bind(self, "handleHarvestBackwallTile", realmID))
end
function IndicatorSystem.prototype.add(self, entity)
    self.entities:add(entity.id)
end
function IndicatorSystem.prototype.remove(self, entity)
    self.entities:delete(entity.id)
end
function IndicatorSystem.prototype.handleInsight(self)
    for ____, entityID in __TS__Iterator(self.entities) do
        local entity = EntityManager.get(entityID)
        local render = entity.render
        if render.atlas ~= INVALID_ATLAS_HANDLE then
            local resource = entity.indicator.resource
            local animation = RESOURCE_INSIGHT_ANIMATION:get(resource)
            if animation then
                animator.play(entity, animation, true)
            end
        end
    end
end
function IndicatorSystem.prototype.handleHarvestBackwallTile(self, realmID, position, tile)
    local realm = World:get(realmID)
    self:discoverResourceAtPosition(realm, position)
end
function IndicatorSystem.prototype.discoverResourceAtPosition(self, realm, position)
    local foreLayer = realm:getLayer(LayerTypes.Fore)
    local entities = foreLayer.spatialHash:queryCulled(Rect.fromCenter(
        position:asVector(),
        Vector.new(Sizes.SEGMENT, Sizes.SEGMENT)
    ))
    do
        local i = 0
        while i < #entities do
            local entityID = entities[i + 1]
            local entity = EntityManager.get(entityID)
            local indicator = entity.indicator
            if indicator ~= nil and not indicator.isDiscovered and indicator:hasTile(position) then
                self:discover(entity, indicator)
            end
            i = i + 1
        end
    end
end
function IndicatorSystem.prototype.discoverResourceAttached(self, realm, entity)
    local foreLayer = realm:getLayer(LayerTypes.Fore)
    local entities = foreLayer.spatialHash:queryCulled(Rect.fromCenter(
        entity.transform.position,
        Vector.new(Sizes.SEGMENT, Sizes.SEGMENT)
    ))
    do
        local i = 0
        while i < #entities do
            local nearbyID = entities[i + 1]
            local nearby = EntityManager.get(nearbyID)
            local indicator = nearby.indicator
            if indicator ~= nil and not indicator.isDiscovered and indicator.attached == entity.id then
                self:discover(nearby, indicator)
            end
            i = i + 1
        end
    end
end
function IndicatorSystem.prototype.discover(self, entity, indicator)
    NotificationSystem:handleDiscoverResource(Item.new(indicator.resource, 0))
    indicator.isDiscovered = true
    entity.animation:stop()
    entity.render.atlas = INVALID_ATLAS_HANDLE
    GameEvents.resourceDiscovered:invoke(entity, indicator)
end
IndicatorSystem.ID = HashString("IndicatorSystem")
____exports.IndicatorSystem = IndicatorSystem
return ____exports
