local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__InstanceOf = ____lualib.__TS__InstanceOf
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 2,["13"] = 2,["14"] = 2,["15"] = 3,["16"] = 3,["17"] = 5,["18"] = 5,["20"] = 10,["21"] = 11,["22"] = 12,["23"] = 5,["24"] = 14,["25"] = 14,["26"] = 16,["27"] = 17,["28"] = 16,["29"] = 20,["30"] = 21,["31"] = 22,["32"] = 20,["33"] = 25,["34"] = 26,["35"] = 27,["36"] = 25,["37"] = 30,["38"] = 31,["39"] = 32,["40"] = 30,["41"] = 35,["42"] = 36,["43"] = 35,["44"] = 39,["45"] = 40,["46"] = 41,["47"] = 42,["49"] = 44,["50"] = 39,["51"] = 47,["52"] = 48,["53"] = 49,["54"] = 50,["56"] = 52,["57"] = 47,["58"] = 55,["59"] = 56,["60"] = 57,["61"] = 58,["62"] = 59,["63"] = 60,["64"] = 61,["67"] = 64,["71"] = 55,["72"] = 71,["73"] = 72,["74"] = 73,["75"] = 74,["76"] = 75,["77"] = 76,["78"] = 77,["80"] = 71,["81"] = 6,["82"] = 7,["83"] = 7,["84"] = 7,["85"] = 7,["86"] = 7,["87"] = 7,["88"] = 7,["89"] = 6,["90"] = 84,["91"] = 85,["93"] = 88,["94"] = 90,["95"] = 92,["96"] = 92});
local ____exports = {}
local ____loot = require("loot")
local addLoot = ____loot.addLoot
local ____loot = require("utility.loot")
local LootGroup = ____loot.LootGroup
local LootItem = ____loot.LootItem
local ____world = require("world")
local World = ____world.World
local LootSystem = __TS__Class()
LootSystem.name = "LootSystem"
function LootSystem.prototype.____constructor(self)
    self.groups = __TS__New(Map)
    self.batches = __TS__New(Map)
    self.origins = __TS__New(Map)
end
function LootSystem.prototype.initialize(self)
end
function LootSystem.prototype.addGroup(self, key, group)
    self.groups:set(key, group)
end
function LootSystem.prototype.getGroup(self, key)
    local group = self.groups:get(key)
    return group
end
function LootSystem.prototype.addBatch(self, key, lootOrigin, batch)
    self.batches:set(key, batch)
    self.origins:set(key, lootOrigin)
end
function LootSystem.prototype.getBatch(self, key)
    local batch = self.batches:get(key)
    return batch
end
function LootSystem.prototype.getOrigin(self, key)
    return self.origins:get(key)
end
function LootSystem.prototype.getLoot(self, key, canDropBonus, modifier)
    local pool = {}
    for ____, listing in ipairs(self:getBatch(key)) do
        listing:addToPool(pool, modifier or 1, canDropBonus or false)
    end
    return pool
end
function LootSystem.prototype.getPossibleLoot(self, key)
    local items = {}
    for ____, listing in ipairs(self:getBatch(key)) do
        listing:addPossible(items)
    end
    return items
end
function LootSystem.prototype.increaseCategoryDropRate(self, category, amount)
    for ____, batch in __TS__Iterator(self.batches) do
        for ____, listing in ipairs(batch[2]) do
            local contains = false
            for ____, entry in ipairs(listing.loot) do
                if __TS__InstanceOf(entry, LootItem) then
                    contains = EntityManager.get(entry.entityID).item:hasCategory(category)
                end
            end
            if contains then
            end
        end
    end
end
function LootSystem.prototype.populateLoot(self, entity)
    local loot = entity.loot
    if loot.key ~= "" then
        local canDropBonus = World.lootBonuses:get(self:getOrigin(loot.key)) or false
        local items = self:getLoot(loot.key, canDropBonus)
        entity.inventory:get():addAll(items)
        loot.key = ""
    end
end
LootSystem.SCHEMA = Schema.new({SchemaField.new(
    "groups",
    DataTypes.HASHMAP,
    DataTypes.STRING,
    DataTypes.COMPLEX,
    function()
        return __TS__New(LootGroup)
    end
)})
if _G.LootSystem == nil then
    _G.LootSystem = __TS__New(LootSystem)
end
local manager = _G.LootSystem
addLoot(nil, manager)
____exports.LootSystem = manager
____exports.LootSystemType = LootSystem
return ____exports
