local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local Set = ____lualib.Set
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__Decorate = ____lualib.__TS__Decorate
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 2,["17"] = 2,["18"] = 3,["19"] = 3,["20"] = 15,["21"] = 15,["22"] = 16,["24"] = 16,["25"] = 24,["26"] = 25,["27"] = 26,["28"] = 28,["29"] = 29,["30"] = 30,["31"] = 31,["32"] = 32,["33"] = 34,["34"] = 18,["35"] = 19,["36"] = 20,["37"] = 21,["38"] = 18,["39"] = 38,["40"] = 16,["41"] = 40,["42"] = 41,["44"] = 38,["45"] = 45,["46"] = 16,["47"] = 47,["48"] = 48,["50"] = 45,["51"] = 52,["52"] = 53,["53"] = 54,["54"] = 55,["55"] = 56,["56"] = 57,["57"] = 58,["60"] = 52,["61"] = 63,["62"] = 64,["63"] = 65,["64"] = 66,["65"] = 67,["66"] = 68,["67"] = 69,["68"] = 72,["69"] = 73,["70"] = 74,["71"] = 75,["74"] = 79,["75"] = 80,["76"] = 81,["78"] = 83,["79"] = 84,["80"] = 84,["81"] = 84,["82"] = 84,["83"] = 84,["84"] = 84,["85"] = 84,["86"] = 84,["87"] = 85,["88"] = 85,["89"] = 85,["90"] = 85,["91"] = 85,["92"] = 85,["93"] = 85,["94"] = 86,["95"] = 63,["96"] = 89,["97"] = 90,["98"] = 90,["99"] = 90,["100"] = 90,["101"] = 90,["102"] = 90,["103"] = 90,["104"] = 90,["105"] = 90,["106"] = 89,["107"] = 101,["108"] = 102,["109"] = 103,["110"] = 104,["111"] = 105,["112"] = 106,["114"] = 108,["115"] = 109,["117"] = 111,["118"] = 101,["119"] = 115,["120"] = 116,["121"] = 117,["122"] = 118,["123"] = 119,["124"] = 120,["125"] = 121,["126"] = 122,["127"] = 124,["128"] = 125,["129"] = 126,["130"] = 127,["132"] = 129,["133"] = 130,["134"] = 131,["135"] = 132,["137"] = 134,["138"] = 136,["139"] = 137,["141"] = 139,["142"] = 140,["144"] = 115,["145"] = 146,["146"] = 147,["147"] = 146,["148"] = 150,["149"] = 151,["150"] = 152,["151"] = 150,["152"] = 155,["153"] = 156,["154"] = 157,["155"] = 158,["157"] = 160,["158"] = 160,["160"] = 161,["161"] = 162,["162"] = 163,["164"] = 166,["165"] = 167,["167"] = 168,["168"] = 169,["169"] = 170,["171"] = 172,["172"] = 173,["173"] = 175,["174"] = 176,["175"] = 177,["176"] = 178,["177"] = 179,["179"] = 182,["180"] = 183,["187"] = 160,["190"] = 187,["191"] = 155,["192"] = 190,["193"] = 191,["194"] = 192,["196"] = 190,["197"] = 17,["198"] = 15,["199"] = 198});
local ____exports = {}
local ____mechanical = require("components.mechanical")
local MechanicalComponent = ____mechanical.MechanicalComponent
local MechanicalPutType = ____mechanical.MechanicalPutType
local MechanicalStrength = ____mechanical.MechanicalStrength
local ____reload = require("reload")
local reloadable = ____reload.reloadable
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local MechanicalSystem = __TS__Class()
MechanicalSystem.name = "MechanicalSystem"
__TS__ClassExtends(MechanicalSystem, EntitySystem)
function MechanicalSystem.prototype.____constructor(self)
    EntitySystem.prototype.____constructor(self)
    self.observed = __TS__New(Map)
    self.ids = 1
    self.connections = __TS__New(Map)
    self.explored = __TS__New(Set)
    self.destroyed = __TS__New(Set)
    self.dirty = __TS__New(Set)
    self.canActivate = true
    self.isActivate = false
end
function MechanicalSystem.register(self)
    local system = __TS__New(MechanicalSystem)
    SystemManager.registerSystem(MechanicalSystem.ID, system, 1)
    SystemManager.associate(MechanicalSystem.ID, MechanicalComponent.cid)
end
function MechanicalSystem.prototype.add(self, entity, component)
    EntitySystem.prototype.add(self, entity, component)
    if component.observeSignal then
        self.observed:set(entity.id, component)
    end
end
function MechanicalSystem.prototype.remove(self, entity, component)
    EntitySystem.prototype.remove(self, entity, component)
    if component.observeSignal then
        self.observed:delete(entity.id)
    end
end
function MechanicalSystem.prototype.update(self, frameTime)
    for ____, observed in __TS__Iterator(self.observed) do
        if observed[2]:isSignalReady() then
            self.explored:clear()
            local entity = EntityManager.get(observed[1])
            local mechanical = observed[2]
            self:sendSignal(entity, mechanical, mechanical.signal, mechanical.signalIndex)
        end
    end
end
function MechanicalSystem.prototype.connect(self, output, outputIndex, input, inputIndex)
    local outputMechanical = output.mechanical
    assert(outputMechanical, "Output is missing mechanical component")
    local inputMechanical = input.mechanical
    assert(inputMechanical, "Input is missing mechanical component")
    local nodeType = outputMechanical:getOutput(outputIndex).type
    assert(nodeType == inputMechanical:getInput(inputIndex).type)
    for ____, connectionId in __TS__Iterator(outputMechanical:getOutput(outputIndex).connections) do
        local connection = self.connections:get(connectionId)
        if connection and connection.input == input.id and connection.inputIndex == inputIndex then
            return 0
        end
    end
    self.ids = self.ids + 1
    while self.connections:has(self.ids) do
        self.ids = self.ids + 1
    end
    local id = self.ids
    self:createConnection(
        id,
        output.id,
        outputIndex,
        input.id,
        inputIndex,
        nodeType
    )
    self:setupConnection(
        id,
        output,
        outputMechanical,
        input,
        inputMechanical
    )
    return id
end
function MechanicalSystem.prototype.createConnection(self, id, output, outputIndex, input, inputIndex, nodeType)
    self.connections:set(id, {
        id = id,
        output = output,
        outputIndex = outputIndex,
        input = input,
        inputIndex = inputIndex,
        nodeType = nodeType,
        signal = {strength = MechanicalStrength.None}
    })
end
function MechanicalSystem.prototype.setupConnection(self, id, output, outputMechanical, input, inputMechanical)
    local connection = self.connections:get(id)
    outputMechanical:getOutput(connection.outputIndex).connections:add(id)
    inputMechanical:getInput(connection.inputIndex).connections:add(id)
    if outputMechanical.onConnect then
        outputMechanical:onConnect(output, input, connection, MechanicalPutType.Output)
    end
    if inputMechanical.onConnect then
        inputMechanical:onConnect(output, input, connection, MechanicalPutType.Input)
    end
    log.info((((("Creating connection: " .. tostring(id)) .. " between ") .. tostring(output)) .. " and ") .. tostring(input))
end
function MechanicalSystem.prototype.disconnect(self, id)
    local connection = self.connections:get(id)
    assert(connection)
    log.info((((("Destroying connection " .. tostring(id)) .. " between ") .. tostring(connection.output)) .. " and ") .. tostring(connection.input))
    local output = EntityManager.get(connection.output)
    local outputMechanical = output.mechanical
    local input = EntityManager.get(connection.input)
    local inputMechanical = input.mechanical
    local outputNode = outputMechanical:getOutput(connection.outputIndex)
    outputNode.connections:delete(id)
    if outputNode.connections.size == 0 then
        outputNode.signal = {strength = MechanicalStrength.None}
    end
    local inputNode = inputMechanical:getInput(connection.inputIndex)
    inputNode.connections:delete(id)
    if inputNode.connections.size == 0 then
        inputNode.signal = {strength = MechanicalStrength.None}
    end
    self.connections:delete(id)
    if outputMechanical.onDisconnect then
        outputMechanical:onDisconnect(output, input, connection, MechanicalPutType.Output)
    end
    if inputMechanical.onDisconnect then
        inputMechanical:onDisconnect(output, input, connection, MechanicalPutType.Input)
    end
end
function MechanicalSystem.prototype.hasConnection(self, id)
    return self.connections:has(id)
end
function MechanicalSystem.prototype.getConnection(self, id)
    assert(self.connections:has(id))
    return self.connections:get(id)
end
function MechanicalSystem.prototype.sendSignal(self, output, mechanical, signal, signalIndex)
    log.debug((("Sending signal " .. tostring(signal)) .. " from ") .. tostring(output))
    mechanical.onSendSignal:invoke(output, signal)
    assert(mechanical.outputNodes)
    do
        local i = 0
        while i < #mechanical.outputNodes do
            do
                local outputNode = mechanical.outputNodes[i + 1]
                if outputNode.connections.size == 0 or signalIndex ~= -1 and signalIndex ~= outputNode.index then
                    goto __continue29
                end
                outputNode.signal = signal
                for ____, connectionId in __TS__Iterator(outputNode.connections) do
                    do
                        local connection = self.connections:get(connectionId)
                        if not connection then
                            goto __continue31
                        end
                        self.explored:add(connectionId)
                        connection.signal = signal
                        local input = EntityManager.get(connection.input)
                        local inputMechanical = input.mechanical
                        inputMechanical:getInput(connection.inputIndex).signal = signal
                        if inputMechanical.onReceive then
                            inputMechanical:onReceive(self, output, input, connection)
                        end
                        if mechanical.onSignal then
                            mechanical:onSignal(self, output, input, connection)
                        end
                    end
                    ::__continue31::
                end
            end
            ::__continue29::
            i = i + 1
        end
    end
    mechanical:clearSignal()
end
function MechanicalSystem.prototype.setActivate(self, value)
    if self.canActivate then
        self.isActivate = value
    end
end
MechanicalSystem.ID = HashString("MechanicalSystem")
MechanicalSystem = __TS__Decorate({reloadable}, MechanicalSystem)
____exports.MechanicalSystem = MechanicalSystem
return ____exports
