local ____lualib = require("lualib_bundle")
local __TS__New = ____lualib.__TS__New
local __TS__Class = ____lualib.__TS__Class
local __TS__ArrayIndexOf = ____lualib.__TS__ArrayIndexOf
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["9"] = 1,["10"] = 1,["11"] = 2,["12"] = 2,["13"] = 2,["14"] = 4,["15"] = 6,["16"] = 6,["18"] = 7,["19"] = 6,["20"] = 9,["21"] = 10,["22"] = 11,["23"] = 12,["24"] = 12,["25"] = 9,["26"] = 15,["27"] = 16,["28"] = 17,["29"] = 18,["31"] = 15,["32"] = 22,["33"] = 23,["34"] = 24,["35"] = 25,["37"] = 27,["38"] = 22,["39"] = 30,["40"] = 31,["41"] = 33,["42"] = 34,["43"] = 35,["44"] = 36,["45"] = 38,["46"] = 39,["47"] = 40,["48"] = 41,["49"] = 42,["50"] = 43,["52"] = 46,["53"] = 47,["54"] = 48,["57"] = 52,["58"] = 53,["59"] = 54,["61"] = 57,["62"] = 30,["63"] = 61});
local ____exports = {}
local ____architect = require("architect")
local architect = ____architect.architect
local ____event = require("event")
local Event = ____event.Event
local GameEvents = ____event.GameEvents
GameEvents.plantHarvested = __TS__New(Event)
local PlantSystem = __TS__Class()
PlantSystem.name = "PlantSystem"
function PlantSystem.prototype.____constructor(self)
    self.components = {}
end
function PlantSystem.prototype.add(self, entity)
    local plant = entity.plant
    plant:initialize()
    local ____self_components_0 = self.components
    ____self_components_0[#____self_components_0 + 1] = plant
end
function PlantSystem.prototype.remove(self, entity)
    local index = __TS__ArrayIndexOf(self.components, entity.plant)
    if index ~= -1 then
        __TS__ArraySplice(self.components, index, 1)
    end
end
function PlantSystem.prototype.update(self, frameTime)
    tracy.ZoneBeginN("PlantSystem::update()")
    for ____, component in ipairs(self.components) do
        component:update(frameTime)
    end
    tracy.ZoneEnd()
end
function PlantSystem.prototype.harvest(self, entity, plant, ____type, fluid)
    local stage = plant.stage
    local destroy = true
    local harvest = stage:getHarvest(____type, fluid)
    if harvest ~= nil then
        GameEvents.plantHarvested:invoke(entity)
        if not plant.onHarvest:empty() then
            plant.onHarvest:invoke(entity.id, stage, harvest)
        elseif harvest.loot ~= "" then
            local position = entity.transform.position:copy()
            position:move(plant.dropPosition.x, plant.dropPosition.y)
            architect:dropLoot(entity.location.realm, position, harvest.loot)
        end
        if harvest.stage and harvest.stage ~= -1 and (plant.stages[harvest.stage + 1].revives == 0 or plant.revives > 0) then
            plant:setStage(harvest.stage)
            destroy = false
        end
    end
    if destroy then
        plant:exitStage()
        EntityManager.destroy(entity.id)
    end
    return destroy
end
____exports.PlantSystem = PlantSystem
return ____exports
