local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 4,["15"] = 4,["16"] = 5,["17"] = 5,["18"] = 5,["19"] = 6,["20"] = 6,["21"] = 8,["22"] = 8,["23"] = 8,["24"] = 11,["25"] = 12,["26"] = 13,["27"] = 11,["28"] = 16,["29"] = 8,["30"] = 18,["31"] = 19,["32"] = 20,["34"] = 21,["35"] = 22,["36"] = 16,["37"] = 25,["38"] = 26,["39"] = 27,["42"] = 29,["43"] = 31,["45"] = 32,["46"] = 34,["47"] = 37,["48"] = 38,["50"] = 41,["51"] = 42,["52"] = 43,["53"] = 44,["54"] = 46,["55"] = 47,["56"] = 48,["57"] = 49,["58"] = 50,["59"] = 51,["61"] = 53,["65"] = 57,["66"] = 58,["67"] = 59,["68"] = 60,["70"] = 62,["73"] = 65,["75"] = 68,["76"] = 68,["78"] = 70,["79"] = 71,["80"] = 73,["81"] = 74,["83"] = 76,["84"] = 78,["85"] = 79,["86"] = 80,["87"] = 81,["89"] = 83,["90"] = 84,["96"] = 89,["97"] = 90,["98"] = 91,["99"] = 92,["100"] = 93,["103"] = 97,["104"] = 98,["106"] = 25,["107"] = 102,["108"] = 103,["109"] = 104,["110"] = 105,["111"] = 106,["112"] = 107,["113"] = 108,["114"] = 109,["116"] = 102,["117"] = 113,["118"] = 114,["121"] = 116,["122"] = 117,["125"] = 119,["126"] = 113,["127"] = 122,["128"] = 123,["131"] = 125,["132"] = 126,["134"] = 128,["136"] = 122,["137"] = 132,["138"] = 133,["139"] = 134,["140"] = 135,["141"] = 136,["142"] = 137,["143"] = 138,["144"] = 139,["145"] = 140,["146"] = 141,["147"] = 142,["150"] = 132,["151"] = 147,["152"] = 148,["153"] = 147,["154"] = 151,["155"] = 152,["156"] = 151,["157"] = 9,["158"] = 158,["159"] = 159,["160"] = 160,["161"] = 161,["162"] = 161,["163"] = 161,["164"] = 161,["165"] = 162,["167"] = 165,["168"] = 167});
local ____exports = {}
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local ____core = require("core")
local core = ____core.core
local ____technology = require("systems.technology")
local TechnologyManager = ____technology.TechnologyManager
local ____event = require("event")
local GameEvents = ____event.GameEvents
local ____utility = require("utility")
local idleStructure = ____utility.idleStructure
local runStructure = ____utility.runStructure
local ____world = require("world")
local World = ____world.World
local ResearchSystem = __TS__Class()
ResearchSystem.name = "ResearchSystem"
__TS__ClassExtends(ResearchSystem, EntitySystem)
function ResearchSystem.prototype.initialize(self)
    GameEvents.startResearch:listen(core.cb(self, "handleResearchChange"))
    GameEvents.finishResearch:listen(core.cb(self, "handleResearchChange"))
end
function ResearchSystem.prototype.add(self, entity, component)
    EntitySystem.prototype.add(self, entity, component)
    local technology = TechnologyManager:current()
    if technology then
        component.timer:reset(technology.time)
    end
    entity.inventory.onChange:listen(core.bind(self, "handleInventoryChange", entity.id))
    entity.consumer.onStateChange:listen(core.cb(self, "handleStateChange"))
end
function ResearchSystem.prototype.update(self, frameTime)
    local technology = TechnologyManager:current()
    if technology == nil then
        return
    end
    local progressTime = math.ceil(technology.time / 100)
    for ____, entityID in ipairs(self.entities) do
        do
            local entity = EntityManager.get(entityID)
            local research = entity.research
            if technology.usesEssences and research.type == ResearcherType.Player then
                goto __continue7
            end
            if research.checkItems then
                local inventory = entity.inventory
                local isActive = true
                runStructure(nil, entity)
                for ____, material in ipairs(technology.materials) do
                    local percentage = research:getPercentage(material.entityID)
                    if percentage <= 0 then
                        if inventory:has(material) then
                            inventory:remove(material, false)
                            research:setPercentage(material.entityID, 100)
                        else
                            isActive = false
                        end
                    end
                end
                if research.isActive ~= isActive then
                    research.isActive = isActive
                    if isActive then
                        entity.consumer:addState(ConsumerState.Running)
                    else
                        entity.consumer:removeState(ConsumerState.Running)
                    end
                end
                research.checkItems = false
            end
            if not research.isActive then
                goto __continue7
            end
            local previousRemaining = research.timer:remaining()
            research.timer:updateRestart(math.ceil(frameTime.milliseconds * research.speed * entity.consumer.efficiency * (World.stats.researchSpeed / 100)))
            if math.ceil(previousRemaining / progressTime) == math.ceil(research.timer:remaining() / progressTime) then
                goto __continue7
            end
            technology.research:update(progressTime)
            for ____, material in ipairs(technology.materials) do
                local percentage = research:getPercentage(material.entityID)
                if percentage > 1 then
                    research:setPercentage(material.entityID, percentage - 1)
                else
                    research:setPercentage(material.entityID, 0)
                    research.checkItems = true
                end
            end
        end
        ::__continue7::
    end
    for ____, entityID in ipairs(self.entities) do
        local entity = EntityManager.get(entityID)
        local research = entity.research
        if (not research.isActive or technology.hasResearched) and research.type ~= ResearcherType.Player then
            idleStructure(nil, entity)
        end
    end
    if technology.hasResearched then
        TechnologyManager:research(technology)
    end
end
function ResearchSystem.prototype.handleResearchChange(self, technology)
    for ____, entityID in ipairs(self.entities) do
        local entity = EntityManager.get(entityID)
        local research = entity.research
        research.isActive = false
        research.checkItems = true
        research.timer:reset(technology.time)
        entity.consumer:removeState(ConsumerState.Running)
    end
end
function ResearchSystem.prototype.handleInventoryChange(self, entityID, name, index, item)
    if item:isEmpty() then
        return
    end
    local technology = TechnologyManager:current()
    if technology == nil then
        return
    end
    EntityManager.get(entityID).research.checkItems = true
end
function ResearchSystem.prototype.handleStateChange(self, entityID, state, flag)
    if flag == ConsumerState.Running then
        return
    end
    if bit.band(state, ConsumerState.On) == ConsumerState.On and bit.band(state, ConsumerState.Powered) == ConsumerState.Powered then
        self:resume(entityID)
    else
        self:pause(entityID)
    end
end
function ResearchSystem.prototype.changeActive(self, entityID, isActive)
    local entity = EntityManager.get(entityID)
    local research = entity.research
    if research.isActive ~= isActive then
        local consumer = entity.consumer
        if consumer and isActive then
            consumer:addState(ConsumerState.Running)
            research.checkItems = true
        elseif consumer and not isActive then
            consumer:removeState(ConsumerState.Running)
            research.isActive = false
        end
    end
end
function ResearchSystem.prototype.resume(self, entityID)
    self:changeActive(entityID, true)
end
function ResearchSystem.prototype.pause(self, entityID)
    self:changeActive(entityID, false)
end
ResearchSystem.ID = HashString("ResearchSystem")
if _G.ResearchSystem == nil then
    _G.ResearchSystem = __TS__New(ResearchSystem)
    SystemManager.registerSystem(ResearchSystem.ID, _G.ResearchSystem, 16)
    SystemManager.associate(
        ResearchSystem.ID,
        hash.hash_str32("research")
    )
    log.info("Registering ResearchSystem")
end
local manager = _G.ResearchSystem
____exports.ResearchSystem = manager
return ____exports
