local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local Map = ____lualib.Map
local __TS__New = ____lualib.__TS__New
local __TS__ArraySplice = ____lualib.__TS__ArraySplice
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 5,["13"] = 6,["14"] = 7,["15"] = 5,["16"] = 11,["17"] = 12,["18"] = 14,["19"] = 15,["20"] = 16,["21"] = 18,["23"] = 18,["24"] = 20,["25"] = 21,["28"] = 25,["29"] = 19,["30"] = 18,["31"] = 29,["32"] = 30,["33"] = 30,["34"] = 30,["35"] = 30,["38"] = 34,["39"] = 34,["40"] = 34,["41"] = 34,["42"] = 28,["43"] = 18,["44"] = 38,["45"] = 39,["46"] = 37,["47"] = 18,["48"] = 43,["50"] = 45,["51"] = 45,["52"] = 46,["53"] = 47,["54"] = 48,["55"] = 49,["56"] = 50,["58"] = 45,["61"] = 54,["62"] = 55,["63"] = 56,["64"] = 57,["65"] = 58,["66"] = 59,["67"] = 60,["70"] = 64,["71"] = 65,["73"] = 69,["74"] = 70,["76"] = 72,["77"] = 74,["78"] = 75,["80"] = 77,["81"] = 79,["82"] = 42,["84"] = 83});
local ____exports = {}
local Task = __TS__Class()
Task.name = "Task"
function Task.prototype.____constructor(self, time, callback)
    self.time = time
    self.callback = callback
end
local tasks = {}
local namedTasks = __TS__New(Map)
local updating = false
local queuedTasks = {}
local queuedNamedTasks = __TS__New(Map)
local scheduler = {}
do
    function scheduler.add(self, time, callback)
        if updating then
            queuedTasks[#queuedTasks + 1] = __TS__New(Task, time, callback)
            return
        end
        tasks[#tasks + 1] = __TS__New(Task, time, callback)
    end
    function scheduler.addNamed(self, time, name, callback)
        if updating then
            queuedNamedTasks:set(
                name,
                __TS__New(Task, time, callback)
            )
            return
        end
        namedTasks:set(
            name,
            __TS__New(Task, time, callback)
        )
    end
    function scheduler.stopNamed(self, name)
        namedTasks:delete(name)
        queuedNamedTasks:delete(name)
    end
    function scheduler.update(self, frameTime)
        updating = true
        do
            local index = #tasks - 1
            while index >= 0 do
                local task = tasks[index + 1]
                task.time = task.time - frameTime.milliseconds
                if task.time <= 0 then
                    task:callback()
                    __TS__ArraySplice(tasks, index, 1)
                end
                index = index - 1
            end
        end
        local completed = {}
        for ____, entry in __TS__Iterator(namedTasks) do
            local task = entry[2]
            task.time = task.time - frameTime.milliseconds
            if task.time <= 0 then
                task:callback()
                completed[#completed + 1] = entry[1]
            end
        end
        for ____, name in ipairs(completed) do
            namedTasks:delete(name)
        end
        for ____, entry in ipairs(queuedTasks) do
            tasks[#tasks + 1] = entry
        end
        queuedTasks = {}
        for ____, entry in __TS__Iterator(queuedNamedTasks) do
            namedTasks:set(entry[1], entry[2])
        end
        queuedNamedTasks:clear()
        updating = false
    end
end
____exports.scheduler = scheduler
return ____exports
