local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 5,["15"] = 5,["16"] = 6,["17"] = 6,["18"] = 9,["19"] = 9,["20"] = 9,["21"] = 12,["22"] = 13,["23"] = 12,["24"] = 16,["25"] = 17,["26"] = 16,["27"] = 20,["28"] = 21,["29"] = 23,["30"] = 25,["31"] = 26,["32"] = 27,["33"] = 29,["34"] = 30,["36"] = 35,["37"] = 37,["38"] = 38,["39"] = 39,["40"] = 40,["41"] = 46,["42"] = 47,["44"] = 49,["45"] = 50,["46"] = 51,["47"] = 52,["49"] = 54,["52"] = 57,["53"] = 58,["54"] = 59,["56"] = 63,["57"] = 64,["58"] = 65,["59"] = 66,["60"] = 68,["61"] = 69,["62"] = 70,["68"] = 79,["69"] = 80,["72"] = 84,["73"] = 20,["74"] = 87,["75"] = 88,["76"] = 89,["77"] = 90,["78"] = 92,["79"] = 93,["80"] = 94,["81"] = 95,["82"] = 87,["83"] = 98,["84"] = 99,["85"] = 98,["86"] = 10,["87"] = 105,["88"] = 106,["89"] = 107,["90"] = 108,["91"] = 108,["92"] = 108,["93"] = 108,["94"] = 109,["96"] = 112,["97"] = 114});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____direction = require("direction")
local getDirectionVector = ____direction.getDirectionVector
local ____event = require("event")
local GameEvents = ____event.GameEvents
local ____world = require("world")
local World = ____world.World
local ____base = require("systems.base")
local EntitySystem = ____base.EntitySystem
local SplitterSystem = __TS__Class()
SplitterSystem.name = "SplitterSystem"
__TS__ClassExtends(SplitterSystem, EntitySystem)
function SplitterSystem.prototype.initialize(self)
    GameEvents.createRealm:listen(core.cb(self, "handleCreateRealm"))
end
function SplitterSystem.prototype.handleCreateRealm(self, realm)
    realm.items.onUpdateTransport:listen(core.bind(self, "handleUpdateTransport", realm.id))
end
function SplitterSystem.prototype.handleUpdateTransport(self, realmID, frameTime)
    tracy.ZoneBeginN("SplitterSystem::update()")
    local items = World:get(realmID).items
    for ____, entityID in ipairs(self.entities) do
        local entity = EntityManager.get(entityID)
        local splitter = entity.splitter
        if splitter.position:isDefault() then
            self:updateSplitter(entity, splitter)
        end
        local filterItem = entity.filter.item
        local entityInSplitterId = items:getReadyItem(splitter.position)
        if entityInSplitterId ~= INVALID_ENTITYID then
            local orderedOutputs = {}
            if splitter.outputPriority ~= SplitterPriority.None then
                if filterItem.entityID == entityInSplitterId or filterItem.entityID == INVALID_ENTITYID and items:canPlaceItem(splitter.outputs[splitter.outputPriority + 1]) then
                    orderedOutputs = {splitter.outputPriority}
                else
                    orderedOutputs[#orderedOutputs + 1] = splitter.nextOutput
                    local nextNextOutput = (splitter.nextOutput + 1) % #splitter.outputs
                    if nextNextOutput == splitter.outputPriority then
                        nextNextOutput = (nextNextOutput + 1) % #splitter.outputs
                    end
                    orderedOutputs[#orderedOutputs + 1] = nextNextOutput
                end
            else
                orderedOutputs[#orderedOutputs + 1] = splitter.nextOutput
                orderedOutputs[#orderedOutputs + 1] = (splitter.nextOutput + 1) % #splitter.outputs
                orderedOutputs[#orderedOutputs + 1] = (splitter.nextOutput + 2) % #splitter.outputs
            end
            for ____, possibleOutput in ipairs(orderedOutputs) do
                local output = splitter.outputs[possibleOutput + 1]
                if items:canPlaceItem(output) then
                    items:moveItem(output, splitter.position)
                    splitter.nextOutput = (possibleOutput + 1) % #splitter.outputs
                    if splitter.nextOutput == splitter.outputPriority then
                        splitter.nextOutput = (splitter.nextOutput + 1) % #splitter.outputs
                    end
                    break
                end
            end
        end
        if items:getReadyItem(splitter.input) ~= INVALID_ENTITYID and items:canPlaceItem(splitter.position) then
            items:moveItem(splitter.position, splitter.input)
        end
    end
    tracy.ZoneEnd()
end
function SplitterSystem.prototype.updateSplitter(self, entity, component)
    local position = entity.transform.position:asTileVector()
    local direction = getDirectionVector(nil, entity.placement.direction)
    component.position:set(position.x, position.y)
    component.input:set(position.x - direction.x, position.y - direction.y)
    component.outputs[SplitterPriority.Left + 1]:set(position.x + direction.y, position.y - direction.x)
    component.outputs[SplitterPriority.Straight + 1]:set(position.x + direction.x, position.y + direction.y)
    component.outputs[SplitterPriority.Right + 1]:set(position.x - direction.y, position.y + direction.x)
end
function SplitterSystem.prototype.handleRotate(self, entity)
    self:updateSplitter(entity, entity.splitter)
end
SplitterSystem.ID = HashString("SplitterSystem")
if _G.SplitterSystem == nil then
    _G.SplitterSystem = __TS__New(SplitterSystem)
    SystemManager.registerSystem(SplitterSystem.ID, _G.SplitterSystem, 0)
    SystemManager.associate(
        SplitterSystem.ID,
        hash.hash_str32("splitter")
    )
    log.info("Registering SplitterSystem")
end
local manager = _G.SplitterSystem
____exports.SplitterSystem = manager
return ____exports
