local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__Iterator = ____lualib.__TS__Iterator
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 4,["13"] = 4,["14"] = 5,["15"] = 5,["16"] = 7,["17"] = 7,["18"] = 7,["19"] = 7,["21"] = 7,["22"] = 10,["23"] = 7,["24"] = 12,["25"] = 13,["26"] = 14,["27"] = 14,["28"] = 14,["29"] = 14,["30"] = 14,["31"] = 15,["32"] = 15,["33"] = 15,["34"] = 15,["35"] = 15,["36"] = 15,["37"] = 15,["38"] = 17,["39"] = 12,["40"] = 20,["41"] = 21,["42"] = 23,["43"] = 25,["44"] = 26,["45"] = 26,["46"] = 26,["47"] = 26,["48"] = 27,["49"] = 28,["52"] = 32,["53"] = 33,["54"] = 33,["55"] = 33,["56"] = 33,["57"] = 34,["58"] = 34,["59"] = 34,["60"] = 34,["61"] = 34,["62"] = 35,["63"] = 35,["64"] = 35,["65"] = 35,["66"] = 35,["67"] = 35,["68"] = 35,["69"] = 35,["70"] = 35,["71"] = 35,["72"] = 35,["73"] = 35,["74"] = 36,["75"] = 38,["76"] = 39,["77"] = 40,["78"] = 41,["79"] = 42,["80"] = 42,["81"] = 42,["82"] = 42,["83"] = 43,["84"] = 44,["85"] = 45,["86"] = 46,["87"] = 46,["88"] = 46,["89"] = 46,["90"] = 46,["91"] = 47,["92"] = 48,["93"] = 49,["95"] = 52,["96"] = 53,["97"] = 54,["98"] = 54,["99"] = 54,["100"] = 54,["101"] = 54,["102"] = 54,["104"] = 56,["105"] = 57,["106"] = 57,["107"] = 57,["108"] = 57,["109"] = 57,["110"] = 57,["111"] = 57,["112"] = 57,["113"] = 57,["114"] = 57,["115"] = 57,["116"] = 58,["117"] = 58,["118"] = 58,["119"] = 58,["120"] = 58,["121"] = 60,["122"] = 60,["123"] = 60,["124"] = 60,["125"] = 61,["126"] = 63,["127"] = 20,["128"] = 66,["129"] = 67,["130"] = 68,["131"] = 66,["132"] = 71,["133"] = 72,["134"] = 73,["135"] = 71,["136"] = 76,["137"] = 77,["138"] = 78,["139"] = 76});
local ____exports = {}
local ____base = require("ui.base")
local ViewUI = ____base.ViewUI
local ____core = require("core")
local core = ____core.core
local ____tutorial = require("systems.tutorial")
local TutorialSystem = ____tutorial.TutorialSystem
local ____hud = require("ui.hud")
local GUIDE_STYLE = ____hud.GUIDE_STYLE
____exports.GuideUI = __TS__Class()
local GuideUI = ____exports.GuideUI
GuideUI.name = "GuideUI"
__TS__ClassExtends(GuideUI, ViewUI)
function GuideUI.prototype.____constructor(self, ...)
    ViewUI.prototype.____constructor(self, ...)
    self.collapsed = false
end
function GuideUI.prototype.initialize(self)
    self.view = UIManager.createView(self, "GuideUI", "", {GUIDE_STYLE})
    self.container = self.view:add(Panel.new(
        "container",
        PixelVector.new(0, 0),
        Padding.new(7)
    ))
    self.content = self.container:add(
        ElementGroup.new(
            "content",
            PixelVector.new(0, 0)
        ),
        Alignment.TopLeft
    )
    TutorialSystem.onChange:listen(core.cb(self, "handleTutorialChange"))
end
function GuideUI.prototype.handleTutorialChange(self)
    self.content:clear()
    local group = TutorialSystem.group
    if self.collapsed then
        local icon = self.content:add(
            Image.new("tutorial-icon"),
            Alignment.TopLeft
        )
        icon.onActivate:listen(core.cb(self, "onActivateTutorialIcon"))
        self.container:resizeToElements(true)
        return
    end
    local headerGroup = self.content:associate(ElementGroup.new("header-group"))
    local icon = headerGroup:add(
        Image.new("icon", "autoforge_window_tutorial_icon"),
        Alignment.TopLeft
    )
    local header = headerGroup:addRelative(
        Label.new("header", group.name),
        Alignment.RightTop,
        pad.left(4)
    )
    headerGroup:add(
        Panel.new(
            "header-line",
            PixelVector.new(
                math.floor(header:getArea().width / UIManager.scale()) + 20,
                3
            )
        ),
        Alignment.BottomLeft,
        icon,
        pad.topLeft(5, 5)
    )
    self.content:add(headerGroup, Alignment.TopLeft)
    local tasksGroup = self.content:associate(ElementGroup.new("tasks-group"))
    local tasks = tasksGroup:associate(ElementGroup.new("tasks"))
    for ____, task in __TS__Iterator(group.tasks:values()) do
        local taskGroup = tasks:associate(ElementGroup.new("task-group"))
        local checkbox = taskGroup:add(
            Image.new("checkbox"),
            Alignment.TopLeft
        )
        local isCompleted = TutorialSystem.completed:has(task.id)
        local progress = task.progress and task:progress(task, isCompleted) or ""
        local formattedText = task.textArg == nil and locale.get(task.text) or locale.format(task.text, task.textArg)
        local info = taskGroup:addRelative(
            Label.new("info", (formattedText .. " ") .. progress),
            Alignment.RightTop,
            pad.left(4)
        )
        if isCompleted then
            checkbox:setClass("checked")
            info:setClass("completed")
        end
        local formattedTooltip = task.tooltipArg == nil and locale.get(task.tooltip) or locale.format(task.tooltip, task.tooltipArg)
        taskGroup.onShowTooltip:listen(core.bind(self, "onShowTooltip", formattedText, formattedTooltip))
        tasks:addRelative(
            taskGroup,
            Alignment.TopLeft,
            pad.top(4),
            Alignment.BottomLeft
        )
    end
    tasksGroup:add(tasks, Alignment.TopLeft)
    self.content:addRelative(
        Panel.new(
            "task-line",
            PixelVector.new(
                2,
                math.floor(tasks:getArea().height / UIManager.scale()) - 7
            )
        ),
        Alignment.BottomLeft,
        pad.topLeft(3, 7)
    )
    self.content:addRelative(
        tasksGroup,
        Alignment.RightTop,
        pad.left(4)
    )
    local collapse = self.content:add(
        Image.new("tutorial-collapse"),
        Alignment.TopRight
    )
    collapse.onActivate:listen(core.cb(self, "onActivateCollapse"))
    self.container:resizeToElements(true)
end
function GuideUI.prototype.onShowTooltip(self, header, text, element)
    _G.TutorialSystem:completeTask("MovingAroundTips")
    UIManager.get("Tooltip"):showText(element, header, text)
end
function GuideUI.prototype.onActivateTutorialIcon(self, element)
    self.collapsed = false
    self:handleTutorialChange()
end
function GuideUI.prototype.onActivateCollapse(self, element)
    self.collapsed = true
    self:handleTutorialChange()
end
return ____exports
