local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 7,["14"] = 7,["15"] = 7,["16"] = 14,["17"] = 7,["18"] = 11,["19"] = 12,["20"] = 16,["21"] = 14,["22"] = 19,["23"] = 20,["24"] = 22,["25"] = 23,["26"] = 23,["27"] = 23,["28"] = 23,["29"] = 23,["30"] = 23,["31"] = 23,["32"] = 24,["33"] = 25,["34"] = 27,["35"] = 27,["36"] = 27,["37"] = 27,["38"] = 27,["39"] = 29,["40"] = 30,["41"] = 30,["42"] = 30,["43"] = 30,["44"] = 30,["45"] = 31,["46"] = 32,["47"] = 34,["48"] = 35,["49"] = 35,["50"] = 35,["51"] = 35,["52"] = 35,["53"] = 36,["54"] = 37,["55"] = 39,["56"] = 40,["57"] = 40,["58"] = 40,["59"] = 40,["60"] = 41,["61"] = 41,["62"] = 41,["63"] = 41,["64"] = 41,["65"] = 42,["66"] = 42,["67"] = 42,["68"] = 42,["69"] = 42,["70"] = 44,["71"] = 19,["72"] = 47,["73"] = 48,["74"] = 49,["75"] = 50,["77"] = 52,["78"] = 53,["79"] = 47,["80"] = 56,["81"] = 57,["82"] = 56,["83"] = 60,["84"] = 61,["85"] = 61,["86"] = 62,["88"] = 60,["89"] = 66,["90"] = 67,["91"] = 68,["92"] = 69,["93"] = 70,["94"] = 71,["95"] = 72,["97"] = 72,["99"] = 74,["100"] = 75,["101"] = 76,["102"] = 77,["103"] = 78,["105"] = 80,["106"] = 81,["108"] = 83,["110"] = 86,["111"] = 87,["113"] = 89,["114"] = 90,["116"] = 66,["117"] = 94,["118"] = 95,["119"] = 96,["120"] = 97,["121"] = 94,["122"] = 100,["123"] = 101,["124"] = 102,["125"] = 103,["126"] = 100,["127"] = 107});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____conduit = require("systems.conduit")
local ConduitSystem = ____conduit.ConduitSystem
local ____base = require("ui.base")
local EntityDialogUI = ____base.EntityDialogUI
local ConduitUI = __TS__Class()
ConduitUI.name = "ConduitUI"
__TS__ClassExtends(ConduitUI, EntityDialogUI)
function ConduitUI.prototype.____constructor(self, player)
    EntityDialogUI.prototype.____constructor(self, player)
    self.inventoryCallbackID = 0
    self.requiredUnlock = false
    self:initialize()
end
function ConduitUI.prototype.initialize(self)
    self:create("Conduit", "Conduit", "Conduit", DialogPlacement.Right)
    local sections = {}
    local content = Section.new(
        SectionType.Content,
        "content",
        PixelVector.new(),
        Padding.new(10),
        true
    )
    self.dialog:associate(content)
    sections[#sections + 1] = content
    content:add(
        Label.new("help", "UiConduitHelp"),
        Alignment.Top,
        Padding.new(0, 0, 0, 0)
    )
    self.infuseButton = Button.new("infuse", "UiConduitInfuse")
    content:addRelative(
        self.infuseButton,
        Alignment.Bottom,
        Padding.new(10, 0, 0, 0)
    )
    self.infuseButton.onActivate:listen(core.cb(self, "handleInfuse"))
    self.infuseButton:disable()
    self.unlockButton = Button.new("unlock", "UiConduitUnlock")
    content:addRelative(
        self.unlockButton,
        Alignment.Bottom,
        Padding.new(10, 0, 0, 0)
    )
    self.unlockButton.onActivate:listen(core.cb(self, "handleUnlock"))
    self.unlockButton:hide()
    local progressGroup = content:associate(ElementGroup.new("progressGroup"))
    progressGroup:add(
        Label.new("name", "UiProgressLabel"),
        Alignment.TopLeft
    )
    self.progressBar = progressGroup:addRelative(
        Bar.new("progress", 200, 0),
        Alignment.BottomLeft,
        Padding.new(5, 0, 0, 0)
    )
    content:addRelative(
        progressGroup,
        Alignment.Bottom,
        Padding.new(10, 0, 0, 0)
    )
    self.dialog:initialize(sections, DialogFeatures.Closable)
end
function ConduitUI.prototype.changedEntity(self, entity, previous)
    if previous then
        assert(self.inventoryCallbackID ~= 0)
        previous.inventory:get().onChange:remove(self.inventoryCallbackID)
    end
    self.inventoryCallbackID = entity.inventory:get().onChange:listen(core.cb(self, "handleInventoryChange"))
    self:updateContent()
end
function ConduitUI.prototype.handleInventoryChange(self, index, item)
    self:updateContent()
end
function ConduitUI.prototype.update(self, frameTime)
    local ____opt_0 = self.view
    if ____opt_0 and ____opt_0:isVisible() then
        self:updateContent()
    end
end
function ConduitUI.prototype.updateContent(self)
    local entity = EntityManager.get(self.entityID)
    local inventory = entity.inventory:get()
    local conduit = entity.conduit
    local requiresUnlock = conduit:requiresUnlock()
    local percentage = requiresUnlock and 0 or (inventory.items[1].quantity + conduit.partition * inventory.stackOverride) / conduit.required
    local ____opt_2 = self.progressBar
    if ____opt_2 ~= nil then
        ____opt_2:set(percentage)
    end
    if requiresUnlock ~= self.requiredUnlock then
        self.requiredUnlock = requiresUnlock
        if requiresUnlock then
            self.unlockButton:show()
            self.infuseButton:hide()
        else
            self.infuseButton:show()
            self.unlockButton:hide()
        end
        self.dialog:getElement("content"):relayout()
    end
    if self.requiredUnlock then
        self.unlockButton:setEnable(ConduitSystem:canUnlock(conduit))
    else
        local isFull = inventory.items[1].quantity == inventory.stackOverride
        self.infuseButton:setEnable(isFull)
    end
end
function ConduitUI.prototype.handleInfuse(self, element)
    local entity = EntityManager.get(self.entityID)
    ConduitSystem:infuse(entity)
    self:updateContent()
end
function ConduitUI.prototype.handleUnlock(self, element)
    local entity = EntityManager.get(self.entityID)
    ConduitSystem:unlockTier(entity)
    self:updateContent()
end
____exports.ConduitUI = ConduitUI
return ____exports
