local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["13"] = 1,["14"] = 1,["15"] = 1,["16"] = 1,["17"] = 1,["18"] = 1,["19"] = 10,["20"] = 10,["21"] = 10,["22"] = 10,["23"] = 10,["24"] = 10,["25"] = 10,["26"] = 10,["27"] = 18,["28"] = 19,["29"] = 20,["30"] = 23,["31"] = 23,["33"] = 31,["34"] = 32,["35"] = 23,["36"] = 34,["37"] = 35,["38"] = 36,["39"] = 36,["40"] = 36,["41"] = 36,["42"] = 36,["43"] = 36,["44"] = 36,["45"] = 37,["46"] = 37,["47"] = 37,["48"] = 37,["49"] = 38,["50"] = 39,["51"] = 39,["52"] = 39,["53"] = 39,["54"] = 39,["55"] = 39,["56"] = 40,["57"] = 41,["58"] = 42,["59"] = 42,["60"] = 42,["61"] = 42,["62"] = 42,["63"] = 42,["64"] = 42,["65"] = 42,["66"] = 42,["67"] = 42,["68"] = 43,["69"] = 44,["70"] = 45,["72"] = 47,["73"] = 47,["74"] = 47,["75"] = 47,["76"] = 47,["77"] = 47,["78"] = 34,["79"] = 50,["80"] = 51,["81"] = 52,["82"] = 53,["83"] = 54,["84"] = 55,["85"] = 56,["86"] = 57,["88"] = 59,["91"] = 50,["92"] = 64,["93"] = 65,["94"] = 66,["95"] = 67,["96"] = 68,["97"] = 69,["98"] = 70,["99"] = 71,["101"] = 74,["102"] = 75,["103"] = 76,["105"] = 78,["107"] = 81,["108"] = 82,["109"] = 83,["110"] = 84,["112"] = 86,["114"] = 89,["115"] = 90,["116"] = 91,["118"] = 93,["120"] = 96,["121"] = 64,["122"] = 99,["123"] = 100,["124"] = 102,["125"] = 103,["126"] = 104,["127"] = 105,["128"] = 106,["130"] = 109,["131"] = 110,["132"] = 111,["133"] = 112,["134"] = 113,["136"] = 115,["139"] = 119,["140"] = 120,["141"] = 121,["143"] = 123,["144"] = 124,["145"] = 125,["146"] = 126,["147"] = 128,["148"] = 99,["149"] = 131,["150"] = 132,["151"] = 133,["152"] = 131,["153"] = 137});
local ____exports = {}
local ItemSlotType = ItemSlotType or ({})
ItemSlotType.Empty = 0
ItemSlotType[ItemSlotType.Empty] = "Empty"
ItemSlotType.Filled = 1
ItemSlotType[ItemSlotType.Filled] = "Filled"
ItemSlotType.Locked = 2
ItemSlotType[ItemSlotType.Locked] = "Locked"
ItemSlotType.Closed = 3
ItemSlotType[ItemSlotType.Closed] = "Closed"
ItemSlotType.ClosedFilled = 4
ItemSlotType[ItemSlotType.ClosedFilled] = "ClosedFilled"
ItemSlotType.ClosedLocked = 5
ItemSlotType[ItemSlotType.ClosedLocked] = "ClosedLocked"
local ITEMSLOT_CLASSES = {
    "",
    "filled",
    "locked",
    "closed",
    "closed-filled",
    "closed-locked"
}
local PLACEHOLDER_CLASS = "placeholder"
local GRABBED_ICON = atlases.get("grabbed")
local LOCKED_ICON = atlases.get("autoforge_window_lock_locked")
local ItemSlotUI = __TS__Class()
ItemSlotUI.name = "ItemSlotUI"
function ItemSlotUI.prototype.____constructor(self)
    self.showQuantity = true
    self.closed = false
end
function ItemSlotUI.prototype.addToParent(self, parent, padding)
    self.group = parent:associate(ElementGroup.new("itemslot"))
    self.background = self.group:add(
        Panel.new(
            "icon_background",
            PixelVector.new(28, 28)
        ),
        Alignment.Left
    )
    self.icon = self.group:add(
        Image.new("icon", "icons_soil"),
        Alignment.Center
    )
    self.icon.floating = true
    self.lock = self.group:add(
        Image.new("lock", LOCKED_ICON),
        Alignment.BottomLeft,
        self.background,
        pad.bottomLeft(8, 2)
    )
    self.lock.floating = true
    self.lock:hide()
    self.quantity = self.group:add(
        Label.new(
            "quantity",
            "999",
            PixelVector.new(24, 0)
        ),
        Alignment.BottomRight,
        self.background,
        pad.bottomRight(11, 2)
    )
    self.quantity.floating = true
    if not self.showQuantity then
        self.quantity:hide()
    end
    parent:addRelative(
        self.group,
        Alignment.TopLeft,
        padding and padding or pad.right(1),
        Alignment.RightTop
    )
end
function ItemSlotUI.prototype.setPlaceholder(self, atlas, placeholderID)
    self.placeholder = atlas
    self.placeholderID = placeholderID
    if not self.quantity:isVisible() then
        if self.placeholder then
            self.icon:setAtlas(self.placeholder)
            self.icon:setClass(PLACEHOLDER_CLASS)
            self.icon:show()
        else
            self.icon:hide()
        end
    end
end
function ItemSlotUI.prototype.update(self, item, locked)
    local icon = self.placeholder
    local cls = PLACEHOLDER_CLASS
    if item.quantity > 0 then
        icon = item.icon
        cls = ""
    elseif locked then
        icon = item.icon
    end
    if locked then
        self.lock:show()
        self.lock:setAtlas(LOCKED_ICON)
    else
        self.lock:hide()
    end
    if icon then
        self.icon:setAtlas(icon)
        self.icon:setClass(cls)
        self.icon:show()
    else
        self.icon:hide()
    end
    if self.showQuantity and item.quantity > 0 then
        self.quantity:setText(tostring(item.quantity))
        self.quantity:show()
    else
        self.quantity:hide()
    end
    self:updateClass()
end
function ItemSlotUI.prototype.updateClass(self)
    local slotType = ItemSlotType.Empty
    local locked = self.lock:isVisible()
    if locked then
        slotType = ItemSlotType.Locked
    elseif self.quantity:isVisible() then
        slotType = ItemSlotType.Filled
    end
    if self.closed then
        if slotType == ItemSlotType.Locked then
            slotType = ItemSlotType.ClosedLocked
        elseif slotType == ItemSlotType.Filled then
            slotType = ItemSlotType.ClosedFilled
        else
            slotType = ItemSlotType.Closed
        end
    end
    local offset = 0
    if locked then
        offset = offset + 1
    end
    self.background.layerOffset = offset
    self.icon.layerOffset = offset
    self.lock.layerOffset = offset
    self.quantity.layerOffset = offset
    self.group:setClass(ITEMSLOT_CLASSES[slotType + 1])
end
function ItemSlotUI.prototype.showGrabbed(self)
    self.icon:setAtlas(GRABBED_ICON)
    self.quantity:hide()
end
____exports.ItemSlotUI = ItemSlotUI
return ____exports
