local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 3,["12"] = 3,["13"] = 4,["14"] = 4,["15"] = 5,["16"] = 5,["17"] = 7,["18"] = 7,["19"] = 9,["20"] = 9,["21"] = 9,["22"] = 7,["23"] = 13,["24"] = 13,["25"] = 13,["26"] = 13,["27"] = 7,["28"] = 18,["29"] = 18,["30"] = 18,["31"] = 18,["32"] = 18,["33"] = 7,["34"] = 7,["35"] = 26,["36"] = 26,["37"] = 26,["38"] = 30,["39"] = 26,["40"] = 27,["41"] = 32,["42"] = 32,["43"] = 32,["44"] = 32,["45"] = 32,["46"] = 33,["47"] = 34,["48"] = 34,["49"] = 34,["50"] = 34,["51"] = 35,["52"] = 35,["53"] = 35,["54"] = 35,["55"] = 35,["56"] = 36,["57"] = 37,["58"] = 30,["59"] = 40,["60"] = 41,["61"] = 42,["62"] = 43,["65"] = 47,["66"] = 40,["67"] = 50,["68"] = 51,["69"] = 52,["70"] = 53,["71"] = 54,["72"] = 55,["73"] = 56,["74"] = 56,["75"] = 56,["76"] = 56,["77"] = 57,["78"] = 58,["79"] = 59,["81"] = 56,["82"] = 56,["83"] = 62,["84"] = 63,["85"] = 64,["86"] = 50,["87"] = 68});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____scheduler = require("systems.scheduler")
local scheduler = ____scheduler.scheduler
local ____utility = require("utility")
local calculateCollectorTiles = ____utility.calculateCollectorTiles
local ____world = require("world")
local World = ____world.World
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local IMAGES = {
    {},
    {
        atlases.get("autoforge_window_collection_1_0"),
        atlases.get("autoforge_window_collection_1_1")
    },
    {
        atlases.get("autoforge_window_collection_2_0"),
        atlases.get("autoforge_window_collection_2_1"),
        atlases.get("autoforge_window_collection_2_2")
    },
    {
        atlases.get("autoforge_window_collection_3_0"),
        atlases.get("autoforge_window_collection_3_1"),
        atlases.get("autoforge_window_collection_3_2"),
        atlases.get("autoforge_window_collection_3_3")
    }
}
local CollectionModuleUI = __TS__Class()
CollectionModuleUI.name = "CollectionModuleUI"
__TS__ClassExtends(CollectionModuleUI, ModuleUI)
function CollectionModuleUI.prototype.____constructor(self, parent)
    ModuleUI.prototype.____constructor(self)
    self.entityID = INVALID_ENTITYID
    self.element = parent:associate(Panel.new(
        "subcontent",
        PixelVector.new(),
        Padding.new(7)
    ))
    local panelGroup = self.element:associate(ElementGroup.new("group"))
    panelGroup:add(
        Label.new("subheader", "UiCollectionLabel"),
        Alignment.TopLeft
    )
    self.tileCollection = panelGroup:addRelative(
        Image.new("tileCollection", IMAGES[4][1]),
        Alignment.Right,
        pad.left(7)
    )
    self.tileCollection.onActivate:listen(core.cb(self, "handleCollectionChange"))
    self.element:add(panelGroup, Alignment.Top)
end
function CollectionModuleUI.prototype.changedEntity(self, entity, previous)
    self.entityID = entity.id
    local collector = entity.collector
    if collector == nil then
        return
    end
    self.tileCollection:setAtlas(IMAGES[collector.reach + 1][collector.range + 1])
end
function CollectionModuleUI.prototype.handleCollectionChange(self, element)
    local entity = EntityManager.get(self.entityID)
    local collector = entity.collector
    collector.range = (collector.range + 1) % (collector.reach + 1)
    collector.visualize = true
    local entityID = self.entityID
    scheduler:addNamed(
        seconds(2),
        "visualize_collection",
        function()
            local entity = EntityManager.get(entityID)
            if entity ~= nil then
                entity.collector.visualize = false
            end
        end
    )
    self.tileCollection:setAtlas(IMAGES[collector.reach + 1][collector.range + 1])
    local ground = World:get(entity.location.realm).ground.map
    calculateCollectorTiles(nil, entity, ground)
end
____exports.CollectionModuleUI = CollectionModuleUI
return ____exports
