local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 3,["15"] = 4,["16"] = 4,["17"] = 6,["18"] = 6,["19"] = 6,["20"] = 13,["21"] = 6,["22"] = 7,["23"] = 10,["24"] = 11,["25"] = 15,["26"] = 15,["27"] = 15,["28"] = 15,["29"] = 15,["30"] = 16,["31"] = 17,["32"] = 18,["33"] = 19,["34"] = 21,["35"] = 21,["36"] = 21,["37"] = 21,["38"] = 22,["39"] = 13,["40"] = 25,["41"] = 26,["42"] = 27,["43"] = 28,["44"] = 30,["45"] = 31,["46"] = 32,["47"] = 33,["48"] = 34,["49"] = 35,["50"] = 35,["51"] = 35,["52"] = 35,["54"] = 37,["57"] = 41,["58"] = 42,["59"] = 43,["60"] = 44,["61"] = 45,["63"] = 47,["64"] = 48,["66"] = 50,["68"] = 53,["69"] = 54,["70"] = 55,["71"] = 56,["73"] = 25,["74"] = 60,["75"] = 61,["76"] = 62,["77"] = 63,["80"] = 67,["81"] = 68,["82"] = 69,["83"] = 60,["84"] = 72,["85"] = 73,["86"] = 72,["87"] = 76,["88"] = 77,["89"] = 78,["90"] = 79,["91"] = 76,["92"] = 83});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____conduit = require("systems.conduit")
local CONDUIT_TIERS = ____conduit.CONDUIT_TIERS
local ConduitSystem = ____conduit.ConduitSystem
local ____technology = require("systems.technology")
local TechnologyID = ____technology.TechnologyID
local TechnologyManager = ____technology.TechnologyManager
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local ConduitModuleUI = __TS__Class()
ConduitModuleUI.name = "ConduitModuleUI"
__TS__ClassExtends(ConduitModuleUI, ModuleUI)
function ConduitModuleUI.prototype.____constructor(self, parent)
    ModuleUI.prototype.____constructor(self)
    self.entityID = INVALID_ENTITYID
    self.requiredUnlock = false
    self.tier = -1
    self.element = parent:associate(Panel.new(
        "subcontent",
        PixelVector.new(220, 0),
        Padding.new(7)
    ))
    self.infuseButton = Button.new("infuse", "UiConduitInfuse")
    self.element:add(self.infuseButton, Alignment.Top)
    self.infuseButton.onActivate:listen(core.cb(self, "handleInfuse"))
    self.infuseButton:disable()
    self.unlockText = self.element:add(
        Paragraph.new("unlock", "", 220),
        Alignment.Top
    )
    self.unlockText:hide()
end
function ConduitModuleUI.prototype.updateContent(self, forceUpdate)
    local entity = EntityManager.get(self.entityID)
    local conduit = entity.conduit
    local requiresUnlock = conduit:requiresUnlock()
    if self.tier ~= conduit.tier then
        self.tier = conduit.tier
        local tier = CONDUIT_TIERS[conduit.tier + 1]
        if tier.technology ~= TechnologyID.None then
            local name = TechnologyManager:get(tier.technology).name
            self.unlockText:setText(locale.format(
                "UIConduitResearchNeeded",
                locale.get(name .. "TechName")
            ))
        else
            self.unlockText:setText("UIConduitLimited")
        end
    end
    if forceUpdate or requiresUnlock ~= self.requiredUnlock then
        self.requiredUnlock = requiresUnlock
        if requiresUnlock then
            self.unlockText:show()
            self.infuseButton:hide()
        else
            self.infuseButton:show()
            self.unlockText:hide()
        end
        self.element:resizeToElements(true)
    end
    if not self.requiredUnlock then
        local inventory = entity.inventory:get()
        local isFull = inventory.items[1].quantity == inventory.stackOverride
        self.infuseButton:setEnable(isFull)
    end
end
function ConduitModuleUI.prototype.changedEntity(self, entity, previous)
    self.entityID = entity.id
    local collector = entity.collector
    if collector == nil then
        return
    end
    self.tier = -1
    self.requiredUnlock = false
    self:updateContent(true)
end
function ConduitModuleUI.prototype.update(self, frameTime, player, entity)
    self:updateContent()
end
function ConduitModuleUI.prototype.handleInfuse(self, element)
    local entity = EntityManager.get(self.entityID)
    ConduitSystem:infuse(entity)
    self:updateContent()
end
____exports.ConduitModuleUI = ConduitModuleUI
return ____exports
