local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 3,["10"] = 3,["11"] = 5,["12"] = 7,["13"] = 7,["14"] = 7,["15"] = 11,["16"] = 7,["17"] = 13,["18"] = 13,["19"] = 13,["20"] = 13,["21"] = 13,["22"] = 14,["23"] = 15,["24"] = 15,["25"] = 15,["26"] = 15,["27"] = 16,["28"] = 16,["29"] = 16,["30"] = 16,["31"] = 16,["32"] = 16,["33"] = 16,["34"] = 16,["35"] = 16,["36"] = 17,["37"] = 18,["38"] = 20,["39"] = 21,["40"] = 21,["41"] = 21,["42"] = 21,["43"] = 22,["44"] = 22,["45"] = 22,["46"] = 22,["47"] = 22,["48"] = 22,["49"] = 22,["50"] = 22,["51"] = 22,["52"] = 23,["53"] = 24,["54"] = 24,["55"] = 24,["56"] = 24,["57"] = 24,["58"] = 11,["59"] = 27,["60"] = 28,["61"] = 27,["62"] = 31,["63"] = 32,["64"] = 31,["65"] = 35,["66"] = 36,["67"] = 37,["68"] = 38,["69"] = 39,["71"] = 41,["72"] = 43,["73"] = 44,["74"] = 45,["75"] = 46,["76"] = 47,["77"] = 48,["78"] = 49,["82"] = 53,["83"] = 54,["84"] = 55,["86"] = 57,["88"] = 60,["89"] = 61,["90"] = 35,["91"] = 64,["92"] = 65,["93"] = 64,["94"] = 69});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local FLUID_PER_MINUTE_MULTIPLIER = 60000 / 1000
local FluidModuleUI = __TS__Class()
FluidModuleUI.name = "FluidModuleUI"
__TS__ClassExtends(FluidModuleUI, ModuleUI)
function FluidModuleUI.prototype.____constructor(self, parent)
    ModuleUI.prototype.____constructor(self)
    self.element = parent:associate(Panel.new(
        "power-module",
        PixelVector.new(),
        Padding.new(7)
    ))
    self.production = self.element:associate(ElementGroup.new("production-group"))
    self.production:add(
        Image.new("icon", "autoforge_window_fluid_value"),
        Alignment.TopLeft
    )
    self.production:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(100, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.production.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIFluidGenerationHeader", "UIFluidGenerationInfo"))
    self.element:add(self.production, Alignment.TopLeft)
    self.demand = self.element:associate(ElementGroup.new("demand-group"))
    self.demand:add(
        Image.new("icon", "autoforge_window_fluid_demand"),
        Alignment.TopLeft
    )
    self.demand:addRelative(
        Label.new(
            "stat",
            "",
            PixelVector.new(100, 0)
        ),
        Alignment.Right,
        pad.left(7)
    )
    self.demand.onShowTooltip:listen(core.bind(self, "onShowTooltip", "UIFluidDemandHeader", "UIFluidDemandInfo"))
    self.element:addRelative(
        self.demand,
        Alignment.BottomLeft,
        pad.top(7)
    )
end
function FluidModuleUI.prototype.changedEntity(self, entity, previous)
    self:updateInfo(entity)
end
function FluidModuleUI.prototype.update(self, frameTime, player, entity)
    self:updateInfo(entity)
end
function FluidModuleUI.prototype.updateInfo(self, entity)
    local demand = 0
    local source = entity.fluidSource
    if source ~= nil then
        demand = source.demand
    end
    self.demand:getElement("stat"):setText(tostring(demand * FLUID_PER_MINUTE_MULTIPLIER))
    local wellspring = entity.wellspring
    if wellspring == nil then
        if entity.placement ~= nil then
            local supportEntityID = entity.placement.axis.supportEntity
            if supportEntityID ~= INVALID_ENTITYID then
                local supportEntity = EntityManager.get(supportEntityID)
                wellspring = supportEntity.wellspring
            end
        end
    end
    if wellspring ~= nil then
        self.production:getElement("stat"):setText(tostring(wellspring.generation * FLUID_PER_MINUTE_MULTIPLIER))
        self.production:show()
    else
        self.production:hide()
    end
    self.demand:show()
    self.element:resizeToElements(true)
end
function FluidModuleUI.prototype.onShowTooltip(self, header, text, element)
    UIManager.get("Tooltip"):showText(element, header, text)
end
____exports.FluidModuleUI = FluidModuleUI
return ____exports
