local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__New = ____lualib.__TS__New
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["8"] = 1,["9"] = 1,["10"] = 2,["11"] = 2,["12"] = 3,["13"] = 3,["14"] = 7,["15"] = 7,["16"] = 9,["17"] = 9,["18"] = 9,["19"] = 16,["20"] = 9,["21"] = 10,["22"] = 11,["23"] = 13,["24"] = 18,["25"] = 19,["26"] = 20,["27"] = 20,["28"] = 20,["29"] = 20,["30"] = 21,["31"] = 21,["32"] = 21,["33"] = 21,["34"] = 21,["35"] = 21,["36"] = 21,["37"] = 22,["38"] = 23,["39"] = 24,["40"] = 25,["41"] = 25,["42"] = 25,["43"] = 25,["44"] = 26,["45"] = 27,["46"] = 27,["47"] = 27,["48"] = 27,["49"] = 27,["50"] = 28,["51"] = 16,["52"] = 31,["53"] = 32,["54"] = 34,["55"] = 35,["56"] = 36,["58"] = 38,["59"] = 39,["60"] = 40,["62"] = 31,["63"] = 44,["64"] = 45,["65"] = 46,["66"] = 47,["67"] = 48,["71"] = 53,["72"] = 54,["73"] = 55,["74"] = 55,["75"] = 55,["76"] = 55,["77"] = 44,["78"] = 58,["79"] = 59,["80"] = 60,["81"] = 61,["82"] = 62,["83"] = 63,["85"] = 64,["86"] = 64,["87"] = 65,["88"] = 66,["89"] = 64,["92"] = 68,["94"] = 71,["95"] = 72,["96"] = 73,["98"] = 74,["99"] = 74,["100"] = 75,["101"] = 76,["102"] = 74,["105"] = 78,["106"] = 79,["108"] = 82,["109"] = 83,["110"] = 84,["111"] = 85,["113"] = 85,["115"] = 58,["116"] = 88,["117"] = 89,["118"] = 90,["119"] = 91,["120"] = 92,["124"] = 97,["125"] = 88,["126"] = 100,["127"] = 101,["128"] = 100,["129"] = 106});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____item = require("item")
local FluidItem = ____item.FluidItem
local ____world = require("world")
local World = ____world.World
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local FluidSelectModuleUI = __TS__Class()
FluidSelectModuleUI.name = "FluidSelectModuleUI"
__TS__ClassExtends(FluidSelectModuleUI, ModuleUI)
function FluidSelectModuleUI.prototype.____constructor(self, parent, playerID, canChange)
    ModuleUI.prototype.____constructor(self)
    self.playerID = INVALID_ENTITYID
    self.entityID = INVALID_ENTITYID
    self.item = __TS__New(FluidItem, FluidType.None, 0)
    self.playerID = playerID
    self.element = parent:associate(ElementGroup.new("recipe-select-module"))
    local recipeItem = self.element:add(
        ElementGroup.new("itemslot"),
        Alignment.Top
    )
    local background = recipeItem:add(
        Panel.new(
            "recipe-select",
            PixelVector.new(28, 28)
        ),
        Alignment.Left
    )
    background.onShowTooltip:listen(core.cb(self, "onShowTooltipFluid"))
    background.onActivate:listen(core.bind(self, "onActivateFluid"))
    background.onSecondaryActivate:listen(core.bind(self, "onSecondaryActivateFluid"))
    self.icon = recipeItem:add(
        Image.new("icon"),
        Alignment.Center
    )
    self.icon:hide()
    self.element:addRelative(
        Label.new("header", "UIFluidLabel"),
        Alignment.Bottom,
        pad.top(7)
    )
    self.canChange = canChange
end
function FluidSelectModuleUI.prototype.changedEntity(self, entity, previous)
    self.entityID = entity.id
    local ____type = entity.fluidSource.outputs[1].type
    if ____type == FluidType.None then
        self.icon:hide()
    else
        self.item.type = ____type
        self.icon:setAtlas(self.item.icon)
        self.icon:show()
    end
end
function FluidSelectModuleUI.prototype.onActivateFluid(self)
    if self.canChange then
        local entity = EntityManager.get(self.entityID)
        if not self:canChange(entity) then
            audio.start("event:/UI/UI_PIN_GEN")
            return
        end
    end
    local modal = UIManager.get("Modal")
    local modular = UIManager.get("Modular")
    modal:openFluids(
        modular,
        core.cb(self, "onSelectedFluid")
    )
end
function FluidSelectModuleUI.prototype.onSelectedFluid(self, result)
    local entity = EntityManager.get(self.entityID)
    local realm = World:get(entity.location.realm)
    local sink = entity.fluidSink
    if sink ~= nil then
        realm.fluid:removeSinkInputs(entity)
        do
            local i = 0
            while i < sink.count do
                sink:setQuantity(i, 0)
                sink.inputs[i + 1].type = result.type
                i = i + 1
            end
        end
        realm.fluid:addSinkInputs(entity)
    end
    local source = entity.fluidSource
    if source ~= nil then
        realm.fluid:removeSourceOutputs(entity)
        do
            local i = 0
            while i < source.count do
                source.outputs[i + 1].type = result.type
                source:setQuantity(i, 0)
                i = i + 1
            end
        end
        source:setQuantity(0)
        realm.fluid:addSourceOutputs(entity)
    end
    self.item = result
    self.icon:setAtlas(self.item.icon)
    self.icon:show()
    local ____opt_0 = entity.event.fluidChange
    if ____opt_0 ~= nil then
        ____opt_0:invoke(entity)
    end
end
function FluidSelectModuleUI.prototype.onSecondaryActivateFluid(self, element)
    if self.canChange then
        local entity = EntityManager.get(self.entityID)
        if not self:canChange(entity) then
            audio.start("event:/UI/UI_PIN_GEN")
            return
        end
    end
    self:onSelectedFluid(__TS__New(FluidItem, FluidType.None, 0))
end
function FluidSelectModuleUI.prototype.onShowTooltipFluid(self, element)
    UIManager.get("Tooltip"):showFluid(element, self.item)
end
____exports.FluidSelectModuleUI = FluidSelectModuleUI
return ____exports
