local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["7"] = 1,["8"] = 1,["9"] = 2,["10"] = 2,["11"] = 4,["12"] = 4,["13"] = 4,["14"] = 7,["15"] = 4,["16"] = 10,["17"] = 11,["18"] = 12,["19"] = 12,["20"] = 12,["21"] = 12,["22"] = 13,["23"] = 13,["24"] = 13,["25"] = 13,["26"] = 13,["27"] = 14,["28"] = 7,["29"] = 17,["30"] = 17,["31"] = 19,["32"] = 20,["33"] = 19,["34"] = 23,["35"] = 24,["36"] = 23,["37"] = 28,["38"] = 28,["39"] = 28,["40"] = 29,["41"] = 30,["42"] = 31,["43"] = 32,["45"] = 29,["46"] = 37,["47"] = 37,["48"] = 37,["49"] = 38,["50"] = 39,["51"] = 40,["52"] = 41,["54"] = 38,["55"] = 46,["56"] = 46,["57"] = 46,["58"] = 47,["59"] = 48,["60"] = 49,["63"] = 53,["64"] = 54,["65"] = 55,["66"] = 56,["67"] = 47,["68"] = 61,["69"] = 62,["70"] = 63});
local ____exports = {}
local ____husbandry = require("systems.husbandry")
local HusbandrySystem = ____husbandry.HusbandrySystem
local ____module = require("ui.modules.module")
local ModuleUI = ____module.ModuleUI
local ProgressModuleUI = __TS__Class()
ProgressModuleUI.name = "ProgressModuleUI"
__TS__ClassExtends(ProgressModuleUI, ModuleUI)
function ProgressModuleUI.prototype.____constructor(self, parent)
    ModuleUI.prototype.____constructor(self)
    self.element = parent:associate(ElementGroup.new("progress-module"))
    local group = self.element:associate(ElementGroup.new("group"))
    group:add(
        Label.new("name", "UiProgressLabel"),
        Alignment.TopLeft
    )
    self.bar = group:addRelative(
        Bar.new("progress", 200, 0),
        Alignment.BottomLeft,
        pad.top(4)
    )
    self.element:add(group, Alignment.Top)
end
function ProgressModuleUI.prototype.updateBar(self, entity)
end
function ProgressModuleUI.prototype.changedEntity(self, entity, previous)
    self:updateBar(entity)
end
function ProgressModuleUI.prototype.update(self, frameTime, player, entity)
    self:updateBar(entity)
end
local HusbandryProgressModuleUI = __TS__Class()
HusbandryProgressModuleUI.name = "HusbandryProgressModuleUI"
__TS__ClassExtends(HusbandryProgressModuleUI, ProgressModuleUI)
function HusbandryProgressModuleUI.prototype.updateBar(self, entity)
    local active = HusbandrySystem:getActive(entity.id)
    if active ~= nil then
        self.bar:set(active.progress:percentage())
    end
end
local ResearchProgressModuleUI = __TS__Class()
ResearchProgressModuleUI.name = "ResearchProgressModuleUI"
__TS__ClassExtends(ResearchProgressModuleUI, ProgressModuleUI)
function ResearchProgressModuleUI.prototype.updateBar(self, entity)
    local research = EntityManager.get(entity.id).research
    if research ~= nil then
        self.bar:set(research.timer:percentage())
    end
end
local ConduitProgressModuleUI = __TS__Class()
ConduitProgressModuleUI.name = "ConduitProgressModuleUI"
__TS__ClassExtends(ConduitProgressModuleUI, ProgressModuleUI)
function ConduitProgressModuleUI.prototype.updateBar(self, entity)
    local conduit = EntityManager.get(entity.id).conduit
    if conduit == nil then
        return
    end
    local inventory = entity.inventory:get()
    local requiresUnlock = conduit:requiresUnlock()
    local percentage = requiresUnlock and 0 or (inventory.items[1].quantity + conduit.partition * inventory.stackOverride) / conduit.required
    self.bar:set(percentage)
end
____exports.HusbandryProgressModuleUI = HusbandryProgressModuleUI
____exports.ResearchProgressModuleUI = ResearchProgressModuleUI
____exports.ConduitProgressModuleUI = ConduitProgressModuleUI
return ____exports
