local ____lualib = require("lualib_bundle")
local __TS__Class = ____lualib.__TS__Class
local __TS__ClassExtends = ____lualib.__TS__ClassExtends
local __TS__SetDescriptor = ____lualib.__TS__SetDescriptor
local __TS__ParseInt = ____lualib.__TS__ParseInt
local __TS__ParseFloat = ____lualib.__TS__ParseFloat
local __TS__SourceMapTraceBack = ____lualib.__TS__SourceMapTraceBack
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["10"] = 1,["11"] = 1,["12"] = 2,["13"] = 2,["14"] = 5,["15"] = 12,["16"] = 12,["17"] = 12,["18"] = 45,["19"] = 12,["20"] = 13,["21"] = 17,["22"] = 18,["23"] = 47,["24"] = 48,["25"] = 45,["31"] = 24,["33"] = 27,["34"] = 28,["35"] = 29,["45"] = 33,["47"] = 36,["48"] = 37,["49"] = 38,["58"] = 42,["62"] = 51,["63"] = 52,["64"] = 52,["65"] = 52,["66"] = 52,["67"] = 52,["68"] = 52,["69"] = 52,["70"] = 54,["71"] = 55,["72"] = 55,["73"] = 55,["74"] = 55,["75"] = 55,["76"] = 55,["77"] = 55,["78"] = 56,["79"] = 57,["80"] = 59,["81"] = 61,["82"] = 61,["83"] = 61,["84"] = 61,["85"] = 61,["86"] = 62,["87"] = 64,["88"] = 64,["89"] = 64,["90"] = 64,["91"] = 64,["92"] = 65,["93"] = 67,["94"] = 67,["95"] = 67,["96"] = 67,["97"] = 67,["98"] = 68,["99"] = 70,["100"] = 72,["101"] = 74,["102"] = 74,["103"] = 74,["104"] = 74,["105"] = 75,["106"] = 76,["107"] = 78,["108"] = 78,["109"] = 78,["110"] = 78,["111"] = 78,["112"] = 79,["113"] = 81,["114"] = 81,["115"] = 81,["116"] = 81,["117"] = 81,["118"] = 83,["119"] = 83,["120"] = 83,["121"] = 83,["122"] = 83,["123"] = 84,["124"] = 85,["125"] = 87,["126"] = 87,["127"] = 87,["128"] = 87,["129"] = 87,["130"] = 89,["131"] = 51,["132"] = 92,["133"] = 93,["134"] = 92,["135"] = 96,["136"] = 97,["137"] = 96,["138"] = 100,["139"] = 101,["140"] = 100,["141"] = 104,["142"] = 105,["143"] = 106,["144"] = 104,["145"] = 109,["146"] = 110,["147"] = 109,["148"] = 113,["149"] = 114,["150"] = 113,["151"] = 118});
local ____exports = {}
local ____core = require("core")
local core = ____core.core
local ____base = require("ui.base")
local DialogUI = ____base.DialogUI
local DEBUGGER_STYLE = {numericOnly = {seed = true, speed = true}}
local WorldgenDebugger = __TS__Class()
WorldgenDebugger.name = "WorldgenDebugger"
__TS__ClassExtends(WorldgenDebugger, DialogUI)
function WorldgenDebugger.prototype.____constructor(self, terraformer)
    DialogUI.prototype.____constructor(self)
    self.files = {}
    self._seed = 0
    self._speed = 0
    self.terraformer = terraformer
    self:initialize()
end
__TS__SetDescriptor(
    WorldgenDebugger.prototype,
    "seed",
    {
        get = function(self)
            return self._seed
        end,
        set = function(self, value)
            self._seed = value
            self.seedLabel:setText(tostring(self._seed))
        end
    },
    true
)
__TS__SetDescriptor(
    WorldgenDebugger.prototype,
    "speed",
    {
        get = function(self)
            return self._speed
        end,
        set = function(self, value)
            self._speed = value
            self.speedLabel:setText(tostring(self._speed))
        end
    },
    true
)
__TS__SetDescriptor(
    WorldgenDebugger.prototype,
    "content",
    {get = function(self)
        return self._content
    end},
    true
)
function WorldgenDebugger.prototype.initialize(self)
    self:create(
        "WorldgenDebugger",
        "AutoForge",
        "WorldgenDebugger",
        DialogPlacement.Center,
        {DEBUGGER_STYLE}
    )
    local sections = {}
    self._content = Section.new(
        SectionType.Content,
        "content",
        PixelVector.new(),
        Padding.new(10),
        true
    )
    self.dialog:associate(self.content)
    sections[#sections + 1] = self.content
    local buttonGroup = self.content:associate(ElementGroup.new("top_buttons"))
    local pauseButton = buttonGroup:add(
        Button.new("pause", "Pause"),
        Alignment.TopLeft,
        Padding.new(5, 0, 0, 5)
    )
    pauseButton.onActivate:listen(core.cb(self, "handlePause"))
    local nextButton = buttonGroup:addRelative(
        Button.new("next", "Next"),
        Alignment.Right,
        Padding.new(0, 0, 0, 5)
    )
    nextButton.onActivate:listen(core.cb(self, "handleNext"))
    local continueButton = buttonGroup:addRelative(
        Button.new("continue", "Continue"),
        Alignment.Right,
        Padding.new(0, 0, 0, 5)
    )
    continueButton.onActivate:listen(core.cb(self, "handleContinue"))
    self.content:add(buttonGroup)
    local seedGroup = self.content:associate(ElementGroup.new("seedGroup"))
    self.seedLabel = seedGroup:add(
        EditLabel.new("seed", "World Seed"),
        Alignment.TopLeft
    )
    self.seedLabel.onTextChange:listen(core.cb(self, "handleSeedChange"))
    self.seedLabel:setClass("fulltime")
    local restartButton = seedGroup:addRelative(
        Button.new("restart", "Restart"),
        Alignment.Right,
        Padding.new(0, 0, 0, 5)
    )
    restartButton.onActivate:listen(core.cb(self, "handleRestart"))
    self.content:addRelative(
        seedGroup,
        Alignment.BottomLeft,
        Padding.new(5, 0, 0, 5)
    )
    self.speedLabel = self.content:addRelative(
        EditLabel.new("speed", "World Speed"),
        Alignment.BottomLeft,
        Padding.new(5, 0, 0, 0)
    )
    self.speedLabel.onLoseFocus:listen(core.cb(self, "handleSpeedChange"))
    self.speedLabel:setClass("fulltime")
    self.action = self.content:addRelative(
        Label.new("action", ""),
        Alignment.BottomLeft,
        Padding.new(10, 0, 0, 0)
    )
    self.dialog:initialize(sections, DialogFeatures.None)
end
function WorldgenDebugger.prototype.handlePause(self, element)
    self.terraformer:pause()
end
function WorldgenDebugger.prototype.handleNext(self, element)
    self.terraformer:next()
end
function WorldgenDebugger.prototype.handleContinue(self, element)
    self.terraformer:resume()
end
function WorldgenDebugger.prototype.handleRestart(self, element)
    log.info("Starting worldgen with seed: " .. tostring(self.seed))
    self:restartCallback()
end
function WorldgenDebugger.prototype.handleSeedChange(self, element)
    self.seed = __TS__ParseInt(element:getText())
end
function WorldgenDebugger.prototype.handleSpeedChange(self, element)
    self.speed = __TS__ParseFloat(element:getText())
end
____exports.WorldgenDebugger = WorldgenDebugger
return ____exports
