$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
SAMPLER2D(s_colormap, 1);
uniform vec4 time; // x (hours fraction), y (minutes fraction), z (hours in day)

void main()
{
    vec2 currentTime = vec2(time.x, 0.8);
    vec2 nextTime = vec2(time.x + 1 / time.z, 0.8);
    vec4 currentTint = mix(texture2D(s_colormap, currentTime), texture2D(s_colormap, nextTime), time.y);
    gl_FragColor = texture2D(s_texture, v_texcoord0) * currentTint * v_color0;
}
