$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
SAMPLER2D(s_main_texture, 1);
SAMPLER2D(s_main_depth, 2);
SAMPLER2D(s_illum_depth, 3);

void main()
{
    float illumDepth = texture2D(s_illum_depth, v_texcoord0.xy).x;
    float targetDepth = texture2D(s_main_depth, v_texcoord0.xy).x;

    if (illumDepth <= targetDepth) {
        vec4 illumColor = texture2D(s_texture, v_texcoord0.xy);
        vec4 targetColor = texture2D(s_main_texture, v_texcoord0.xy);
        gl_FragColor = vec4(targetColor.rgb, illumColor.r);
    } else {
        discard;
    }
}
