$input a_position, a_color0, a_texcoord0, i_data0, i_data1
$output v_color0, v_illum

#include <bgfx_shader.sh>

uniform vec4 u_lighting; // x = tileWidth, y = tileSize, z = z

void main()
{
    //Instance Data
    // index (1) x + y * width
    // lighting value (1)
    // padding (2)
    // rgb (3)
    // padding (1)

    int tileWidth = int(u_lighting.x);
    int tileSize = int(u_lighting.y);
    int index = int(i_data0.x);
    float value = max(0, i_data0.y);
    vec2 position = vec2(index % tileWidth * tileSize + 1, index / tileWidth * tileSize + 1);
    mat4 projViewWorld = mul(mul(u_proj, u_view), u_model[0]);
    gl_Position = mul(projViewWorld, vec4(position + a_position.xy * tileSize, u_lighting.z, 1.0));
    v_color0 = vec4(i_data1.rgb / 255.0, value / 255.0);
}
