$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
SAMPLER2D(s_overlay, 1);
uniform vec4 offset;

void main()
{
    vec4 color = texture2D(s_texture, v_texcoord0).rgba;
    if (color.a < 0.5)
        discard;

    vec2 relative = (v_texcoord0 - v_uv.xy) / (v_uv.zw - v_uv.xy);
    vec2 texcoord1 = offset.xy + relative * offset.zw;
    vec4 overlayColor = texture2D(s_overlay, texcoord1).rgba;
    if (overlayColor.a < 0.5)
        discard;

    gl_FragColor = color * v_color0;
}
