$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
SAMPLER2D(s_colormap, 1);
uniform vec4 tileCount;

void main()
{
    vec4 values = texture2D(s_texture, v_texcoord0);

    // Lighting is obfuscating tile
    if (values.a == 0) {
        gl_FragColor = vec4(0, 0, 0, 1.0);
        return;
    }

    float tileID = values.r * 255 + 1;
    float x = tileID / tileCount.x;
    float layer = values.g * 255;
    float y = layer / tileCount.y;
    gl_FragColor = texture2D(s_colormap, vec2(x, y));
}
