$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);
uniform vec4 data;
uniform vec4 axes;
uniform vec4 top_axes;
uniform vec4 bottom_axes;

float rand(vec2 co){
  return fract(sin(dot(co, vec2(12.9898,78.233))) * 43758.5453);
}

void main()
{
    const vec2 size = vec2(384, 384);
    float x = floor(v_texcoord0.x * size.x) / size.y;
    float y = floor(v_texcoord0.y * size.x) / size.y;
    float value = rand(vec2(x, y));
    vec2 offset = vec2(fract((sin(data.x) + 1) / 256), fract((cos(data.x) + 1) / 256));
    float amount = 10;

    // Right side
    if (axes.x > -1.0 && value < (x - (1.0 - axes.x) + offset.x) * amount) {
        discard;
    }

    // Top side
    if (axes.y > -1.0 && value > (y - axes.y + offset.y) * amount) {
        discard;
    }

    // Left side
    if (axes.z > -1.0 && value > (x - axes.z + offset.x) * amount) {
        discard;
    }

    // Bottom side
    if (axes.w > -1.0 && value < (y - (1.0 - axes.w) + offset.y) * amount) {
        discard;
    }

    // Tops(top right, right top, top left, left top)
    if ((top_axes.y > -1.0 && value > (y - top_axes.y + offset.y) * amount) &&
        (top_axes.x > -1.0 && value < (x - (1.0 - top_axes.x) + offset.x) * amount)) {
            discard;
        }

    if ((top_axes.w > -1.0 && value > (y - top_axes.w + offset.y) * amount) &&
        (top_axes.z > -1.0 && value > (x - top_axes.z + offset.x) * amount)) {
            discard;
        }

    // Bottoms(bottom right, right bottom, bottom left, left bottom)
    if ((bottom_axes.y > -1.0 && value < (y - (1.0 - bottom_axes.y) + offset.y) * amount) &&
        (bottom_axes.x > -1.0 && value < (x - (1.0 - bottom_axes.x) + offset.x) * amount)) {
            discard;
        }

    if ((bottom_axes.w > -1.0 && value < (y - (1.0 - bottom_axes.w) + offset.y) * amount) &&
        (bottom_axes.z > -1.0 && value > (x - bottom_axes.z + offset.x) * amount)) {
            discard;
        }
    gl_FragColor = vec4(0, 0, 0, 1.0);
}
