$input a_position, a_color0, a_texcoord0, i_data0, i_data1, i_data2, i_data3, i_data4
$output v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);

void main()
{
    //Instance Data
    // UV (4)
    // Color (4)
    // position (2)
    // origin (2)
    // scale (2)
    // angle (1)
    // z (1)
    // textureSize (2)
    // illumination (1)

    vec2 origin = i_data2.zw / i_data0.zw;
    mat4 projViewWorld = mul(mul(u_proj, u_view), u_model[0]);
    mat2 rotation = mat2(cos(i_data3.z),-sin(i_data3.z), sin(i_data3.z),cos(i_data3.z));
    // SRT (Scale, Rotate, Translate)
    vec2 position = mul(rotation, (a_position.xy - origin)  * i_data3.xy * i_data0.zw) + i_data2.xy;
    position += origin;
    gl_Position = mul(projViewWorld, vec4(position, i_data3.w, 1.0));
    v_color0 = i_data1 / 255.0;
    v_texcoord0 = (i_data0.xy + i_data0.zw * a_texcoord0) / i_data4.xy;
    v_illum = i_data4.z;
    v_uv = vec4(i_data0.xy / i_data4.xy, (i_data0.xy + i_data0.zw) / i_data4.xy);
}