$input v_color0, v_texcoord0, v_illum, v_uv

#include <bgfx_shader.sh>

SAMPLER2D(s_texture, 0);


vec3 ContrastSaturationBrightness(vec3 color, float brt, float sat, float con)
{
    // Increase or decrease theese values to adjust r, g and b color channels seperately
    const float AvgLumR = 0.5;
    const float AvgLumG = 0.5;
    const float AvgLumB = 0.5;

    const vec3 LumCoeff = vec3(0.2125, 0.7154, 0.0721);

    vec3 AvgLumin = vec3(AvgLumR, AvgLumG, AvgLumB);
    vec3 brtColor = color * brt;
    float i = dot(brtColor, LumCoeff);
    vec3 intensity = vec3(i, i, i);
    vec3 satColor = mix(intensity, brtColor, sat);
    vec3 conColor = mix(AvgLumin, satColor, con);
    return conColor;
}

void main()
{
    vec4 color = texture2D(s_texture, v_texcoord0).rgba;
    if (color.a < 0.5)
        discard;
    gl_FragColor = vec4(ContrastSaturationBrightness(color.rgb, 0.7, 0.7, 1.0), color.a);
}
